uses windows
using meta

void normalizePath(char* s)
	lg=strlen(s)
	for i=0:lg-1
		c=(int)s[i]
		if c=='/':
			s[i]='\\';
		elif c>='a'&&c<='z':
			s[i]=c+('A'-'a')
	if lg&&s[lg-1]!='\\':
		s[lg++]='\\'

void canceled(char* err)
	MessageBoxA(NULL,err,"Setup not completed",MB_ICONERROR|MB_OK)
	error(err)

void trycopy(char* tar,char* src,char* fname)
	char[260] buf0,buf1
	sprintf(buf0,"%s%s",tar,fname)
	sprintf(buf1,"%s%s",src,fname)
	if !CopyFileA(buf1,buf0,0):
		write-warningf("unable to update ",fname)

void copyit(char* tar,char* src)
	char[260] bufmk
	sprintf(bufmk,"%s%s",tar,"..\\bin");_mkdir(bufmk)
	sprintf(bufmk,"%s%s",tar,"..\\units");_mkdir(bufmk)
	sprintf(bufmk,"%s%s",tar,"..\\rules");_mkdir(bufmk)
	trycopy(tar,src,"ctc.exe")
	trycopy(tar,src,"ed.exe")
	trycopy(tar,src,"..\\rules\\bsgp.rules")
	char[260] buf0,buf1
	sprintf(buf0,"%s%s",tar,"..\\units\\")
	sprintf(buf1,"%s%s",src,"..\\units\\")
	SetCurrentDirectoryA(buf1)
	hf=FindFirstFileA("*.i",&WIN32_FIND_DATAA fd)
	if hf!=INVALID_HANDLE_VALUE:
		do
			trycopy(buf0,buf1,fd.cFileName)
		while FindNextFileA(hf,&fd)

/
	//detect GPU
	((void()())meta.state('pf-detectNVIDIA'))()
	if !(iptr)meta.state('ptx-has-ptxas.exe'):
		if MessageBoxA(NULL,"Can't find CUDA Toolkit in %PATH%. GPU programs won't compile. Cancel setup?",
		"Warning",MB_YESNO|MB_ICONWARNING)==IDYES:
			canceled("Setup canceled")
	else
		if (iptr)meta.state('cuda-ver-major')<1:
			if MessageBoxA(NULL,"Can't find CUDA Driver. GPU programs won't run even if they do compile. Cancel setup?",
			"Warning",MB_YESNO|MB_ICONWARNING)==IDYES:
				canceled("Setup canceled")
	//detect self path and existing installation
	char[260]binpath
	if !GetEnvironmentVariableA("BSGP_BIN_PATH",binpath,256):
		binpath[0]=0
	char[260]buf
	VirtualQuery(meta.wantstr,&MEMORY_BASIC_INFORMATION mbi,sizeof(mbi))
	hulprt=(HMODULE)mbi.AllocationBase
	buf[0]=0
	GetModuleFileNameA(hulprt,buf,256)
	if !buf[0]:
		canceled("Panic: can't find setup itself?")
	lg=strlen(buf)
	for i=lg-1:-1:0
		if buf[i]=='\\'||buf[i]=='/':
			buf[i+1]=0
			lg=i+1
			break
	normalizePath(binpath)
	normalizePath(buf)
	isupdate=0
	char[1024] mbuf
	if strcmp(binpath,buf)!=0||!binpath[0]:
		if binpath[0]:
			write-sprintf(mbuf;'Setup package has been extracted to a path that does not \
match existing BSGP installation at:\n  ',binpath,'\nOverwrite the existing installation for upgrade?')
			if MessageBoxA(NULL,mbuf,"Warning",MB_ICONWARNING|MB_YESNO)==IDYES:
				//copy files
				copyit(binpath,buf)
				strcpy(buf,binpath)
				isupdate=1
			else
				write-sprintf(mbuf;'Setup current package at:\n  ',binpath,' ?\n')
				if MessageBoxA(NULL,mbuf,"Warning",MB_ICONWARNING|MB_YESNO)==IDNO:
					canceled("Setup canceled")
	//visualstudio rule
	char[260] rulepath
	vcpath=binpath
	if GetEnvironmentVariableA("VS90COMNTOOLS",vcpath,256)||GetEnvironmentVariableA("VS80COMNTOOLS",vcpath,256):
		strcat(vcpath,"..\\..\\VC\\VCProjectDefaults\\bsgp.rules")
		write-sprintf(rulepath;buf,"..\\rules\\bsgp.rules")
		if !CopyFileA(rulepath,vcpath,0):
			MessageBoxA(NULL,"Unable to setup BSGP rules in VisualStudio","Error",MB_ICONERROR|MB_OK)
	//set environment variable
	if isupdate:goto noenv
	er=RegCreateKeyExA(HKEY_LOCAL_MACHINE,"System\\CurrentControlSet\\Control\\Session Manager\\Environment",0,NULL,
		REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&HKEY hk,&int how)
	if er!=ERROR_SUCCESS:
		write-sprintf(mbuf;"Failed to set environment variable, please set environment variable\nBSGP_BIN_PATH=",buf,"\nmanually")
		MessageBoxA(NULL,mbuf,"Error",MB_ICONERROR|MB_OK)
		goto noenv
	er=RegSetValueExA(hk,"BSGP_BIN_PATH",0,REG_SZ,buf,strlen(buf)+1)
	if er!=ERROR_SUCCESS:
		write-sprintf(mbuf;"Failed to set environment variable, please set environment variable\nBSGP_BIN_PATH=",buf,"\nmanually")
		MessageBoxA(NULL,mbuf,"Error",MB_ICONERROR|MB_OK)
	RegCloseKey(hk)
	:noenv
	SendMessageTimeoutA(HWND_BROADCAST,WM_SETTINGCHANGE,0,(iptr)"Environment",SMTO_NORMAL,1000,&0)
	error("setup completed")
