/*
 * Copyright 1993-2007 NVIDIA Corporation.  All rights reserved.
 *
 * NOTICE TO USER:
 *
 * This source code is subject to NVIDIA ownership rights under U.S. and
 * international Copyright laws.  Users and possessors of this source code
 * are hereby granted a nonexclusive, royalty-free license to use this code
 * in individual and commercial software.
 *
 * NVIDIA MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOURCE
 * CODE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR
 * IMPLIED WARRANTY OF ANY KIND.  NVIDIA DISCLAIMS ALL WARRANTIES WITH
 * REGARD TO THIS SOURCE CODE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY, NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
 * OF USE, DATA OR PROFITS,  WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION,  ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOURCE CODE.
 *
 * U.S. Government End Users.   This source code is a "commercial item" as
 * that term is defined at  48 C.F.R. 2.101 (OCT 1995), consisting  of
 * "commercial computer  software"  and "commercial computer software
 * documentation" as such terms are  used in 48 C.F.R. 12.212 (SEPT 1995)
 * and is provided to the U.S. Government only as a commercial end item.
 * Consistent with 48 C.F.R.12.212 and 48 C.F.R. 227.7202-1 through
 * 227.7202-4 (JUNE 1995), all U.S. Government End Users acquire the
 * source code with only those rights set forth herein.
 *
 * Any use of this source code in individual and commercial software must
 * include, in the user documentation and internal comments to the code,
 * the above Disclaimer and U.S. Government End Users Notice.
 */
/*
070807 ported to i by hqm
*/
struct CUarray_t
struct CUtexref_t
struct CUstream_st
struct CUevent_st
struct CUDA_ARRAY_DESCRIPTOR
	int Width;
	int Height;
	int Format;
	int NumChannels;
struct CUDA_ARRAY3D_DESCRIPTOR
    int Width;
    int Height;
    int Depth;
    int Format;
    int NumChannels;
    int Flags;
typedef void* CUdeviceptr
typedef CUarray_t* CUarray
typedef CUtexref_t* CUtexref
typedef int CUdevice
typedef void* CUcontext
typedef CUstream_st *CUstream;
typedef CUevent_st *CUevent;
struct CUDA_MEMCPY2D
	int srcXInBytes, srcY;
	int srcMemoryType;
	void* srcHost;
	CUdeviceptr srcDevice;
	CUarray srcArray;
	int srcPitch;
	int dstXInBytes, dstY;
	int dstMemoryType;
	void *dstHost;
	CUdeviceptr dstDevice;
	CUarray dstArray;
	int dstPitch
	int WidthInBytes;
	int Height;
struct CUDA_MEMCPY3D
	int srcXInBytes, srcY, srcZ;
	int srcLOD;
	int srcMemoryType;
	void *srcHost;
	CUdeviceptr srcDevice;
	CUarray srcArray;
	int reserved0;
	int srcPitch;  // ignored when src is array
	int srcHeight; // ignored when src is array; may be 0 if Depth==1

	int dstXInBytes, dstY, dstZ;
	int dstLOD;
	int dstMemoryType;
	void *dstHost;
	CUdeviceptr dstDevice;
	CUarray dstArray;
	int reserved1;
	int dstPitch;  // ignored when dst is array
	int dstHeight; // ignored when dst is array; may be 0 if Depth==1

	int WidthInBytes;
	int Height;
	int Depth;
struct CUdevprop
	int maxThreadsPerBlock;
	int[3] maxThreadsDim;
	int[3] maxGridSize;
	int sharedMemPerBlock;
	int totalConstantMemory;
	int SIMDWidth;
	int memPitch;
	int regsPerBlock;
	int clockRate;
	int textureAlign;
typedef void IDirect3DDevice9
typedef void IDirect3DVertexBuffer9
import "nvcuda.dll"
	int stdcall cuMemGetInfo(iptr* free, iptr* total)
	int stdcall cuMemAlloc( CUdeviceptr *dptr, int bytesize)
	int stdcall cuMemAllocPitch( CUdeviceptr *dptr,
		int *pPitch,
		int WidthInBytes,
		int Height,
		// size of biggest r/w to be performed by kernels on this memory
		// 4, 8 or 16 bytes
		int ElementSizeBytes)
	int stdcall cuMemFree(CUdeviceptr dptr)
	int stdcall cuMemGetAddressRange( CUdeviceptr *pbase, int *psize, CUdeviceptr dptr );
	int stdcall cuMemAllocHost(void **pp, iptr bytesize)
	int stdcall cuMemHostAlloc(void **pp, iptr bytesize, int Flags );
	int stdcall cuMemHostGetDevicePointer( CUdeviceptr *pdptr, void *p, int Flags );
	int stdcall cuMemFreeHost(void *p)
	int stdcall cuModuleGetFunction(void**,void*,char*)
	int stdcall cuModuleGetGlobal(void**,iptr*,void*,char*)
	int stdcall cuModuleGetTexRef(CUtexref*,void*,char*)
	int stdcall cuFuncSetBlockShape(void*,int,int,int)
	int stdcall cuFuncSetSharedSize(void*,int)
	int stdcall cuParamSeti(void*,int,int)
	int stdcall cuParamSetf(void*,int,float)
	int stdcall cuParamSetv(void*,int,void*,iptr)
	int stdcall cuParamSetSize(void*,int)
	int stdcall cuParamSetTexRef(void*,int,CUtexref)
	int stdcall cuLaunchGrid(void*,int,int)
	int stdcall cuModuleLoad(void**,char*)
	int stdcall cuModuleLoadData(void**,void*)
	int stdcall cuModuleLoadDataEx(void**,void*,int numOptions, int* options, void **optionValues);
	int stdcall cuMemsetD8( CUdeviceptr dstDevice,  char uc,  int N )
	int stdcall cuMemsetD16( CUdeviceptr dstDevice,  short us,  int N )
	int stdcall cuMemsetD32( CUdeviceptr dstDevice,  int ui,  int N )
	int stdcall cuMemsetD2D8( CUdeviceptr dstDevice,  int dstPitch,  char uc,  int Width,  int Height );
	int stdcall cuMemsetD2D16( CUdeviceptr dstDevice,  int dstPitch,  short us,  int Width,  int Height );
	int stdcall cuMemsetD2D32( CUdeviceptr dstDevice,  int dstPitch,  int ui,  int Width,  int Height );
	int stdcall cuMemcpyHtoD (CUdeviceptr dstDevice, void *srcHost, int ByteCount );
	int stdcall cuMemcpyDtoH (void *dstHost, CUdeviceptr srcDevice, int ByteCount );
	int stdcall cuMemcpyDtoD (CUdeviceptr dstDevice, CUdeviceptr srcDevice, int ByteCount );
	int stdcall cuMemcpyDtoA ( CUarray dstArray, int dstIndex, CUdeviceptr srcDevice, int ByteCount );
	int stdcall cuMemcpyAtoD ( CUdeviceptr dstDevice, CUarray hSrc, int SrcIndex, int ByteCount );
	int stdcall cuMemcpyHtoA( CUarray dstArray, int dstIndex, void *pSrc, int ByteCount );
	int stdcall cuMemcpyAtoH( void *dstHost, CUarray srcArray, int srcIndex, int ByteCount );
	int stdcall cuMemcpyAtoA( CUarray dstArray, int dstIndex, CUarray srcArray, int srcIndex, int ByteCount );
	int stdcall cuTexRefSetArray( CUtexref hTexRef, CUarray hArray, int Flags );
	int stdcall cuTexRefSetAddress( int *ByteOffset, CUtexref hTexRef, CUdeviceptr dptr, int bytes );
	int stdcall cuTexRefSetAddress2D( CUtexref hTexRef, CUDA_ARRAY_DESCRIPTOR *desc, CUdeviceptr dptr, int Pitch);
	int stdcall cuTexRefSetFormat( CUtexref hTexRef, int fmt, int NumPackedComponents );
	int stdcall cuTexRefSetAddressMode( CUtexref hTexRef, int dim, int am );
	int stdcall cuTexRefSetFilterMode( CUtexref hTexRef, int fm );
	int stdcall cuTexRefSetFlags( CUtexref hTexRef, int Flags );
	int stdcall cuTexRefGetAddress( CUdeviceptr *pdptr, CUtexref hTexRef );
	int stdcall cuTexRefGetArray( CUarray *phArray, CUtexref hTexRef );
	int stdcall cuTexRefGetAddressMode( int *pam, CUtexref hTexRef, int dim );
	int stdcall cuTexRefGetFilterMode( int *pfm, CUtexref hTexRef );
	int stdcall cuTexRefGetFormat( int *pFormat, int *pNumChannels, CUtexref hTexRef );
	int stdcall cuTexRefGetFlags( int *pFlags, CUtexref hTexRef );
	int stdcall cuInit(int Flags);
	int stdcall cuDeviceGet(CUdevice *device, int ordinal);
	int stdcall cuDeviceGetCount(int *count);
	int stdcall cuDeviceGetName(char *name, int len, CUdevice dev);
	int stdcall cuDeviceComputeCapability(int *major, int *minor, CUdevice dev);
	int stdcall cuDeviceTotalMem(int *bytes, CUdevice dev);
	int stdcall cuDeviceGetProperties(CUdevprop *prop, CUdevice dev);
	int stdcall cuDeviceGetAttribute(int *pi, int attrib, CUdevice dev);
	int stdcall cuCtxCreate(CUcontext *pctx, int flags, CUdevice dev );
	int stdcall cuCtxAttach(CUcontext *pctx, int flags);
	int stdcall cuCtxDetach(CUcontext ctx);
	int stdcall cuCtxPushCurrent(CUcontext ctx);
	int stdcall cuCtxPopCurrent(CUcontext *pctx);
	int stdcall cuCtxGetDevice(CUdevice *device);
	int stdcall cuCtxSynchronize();
	int stdcall cuArrayCreate( CUarray *pHandle, CUDA_ARRAY_DESCRIPTOR *pAllocateArray );
	int stdcall cuArray3DCreate( CUarray *pHandle, CUDA_ARRAY3D_DESCRIPTOR *pAllocateArray );
	int stdcall cuArrayGetDescriptor( CUDA_ARRAY_DESCRIPTOR *pArrayDescriptor, CUarray hArray );
	int stdcall cuArray3DGetDescriptor( CUDA_ARRAY3D_DESCRIPTOR *pArrayDescriptor, CUarray hArray );
	int stdcall cuArrayDestroy( CUarray hArray );
	int stdcall cuMemcpy2D( CUDA_MEMCPY2D *pCopy );
	int stdcall cuMemcpy2DUnaligned( CUDA_MEMCPY2D *pCopy );
	int stdcall cuMemcpy3D( CUDA_MEMCPY3D *pCopy );
	int stdcall cuGLInit();
	int stdcall cuGLRegisterBufferObject( u32 bufferobj );
	int stdcall cuGLMapBufferObject( CUdeviceptr *dptr, int *size,  u32 bufferobj );
	int stdcall cuGLUnmapBufferObject( u32 bufferobj );
	int stdcall cuGLUnregisterBufferObject( u32 bufferobj );
	int stdcall cuD3D9Begin(IDirect3DDevice9 *pDevice);
	int stdcall cuD3D9RegisterVertexBuffer(IDirect3DVertexBuffer9 *pVB);
	int stdcall cuD3D9UnregisterVertexBuffer(IDirect3DVertexBuffer9 *pVB);
	int stdcall cuD3D9MapVertexBuffer(CUdeviceptr *dptr, int *size, IDirect3DVertexBuffer9 *pVB);
	int stdcall cuD3D9UnmapVertexBuffer(IDirect3DVertexBuffer9 *pVB);
	int stdcall cuD3D9End();
	/////////////////////////////
	int stdcall cuMemcpyHtoDAsync (void* dstDevice,void *srcHost, int ByteCount,CUstream hStream );
	int stdcall cuMemcpyDtoHAsync (void *dstHost,void* srcDevice, int ByteCount,CUstream hStream );
	int stdcall cuMemcpyHtoAAsync(CUarray dstArray, int dstIndex,void *pSrc, int ByteCount,CUstream hStream );
	int stdcall cuMemcpyAtoHAsync(void *dstHost,CUarray srcArray, int srcIndex, int ByteCount,CUstream hStream );
	int stdcall cuMemcpy2DAsync(CUDA_MEMCPY2D *pCopy,CUstream hStream );
	int stdcall cuMemcpy3DAsync(CUDA_MEMCPY3D *pCopy,CUstream hStream );
	int stdcall cuLaunchGridAsync(void* f,int grid_width,int grid_height,CUstream hStream );
	int stdcall cuEventCreate( CUevent *phEvent,  int Flags );
	int stdcall cuEventRecord( CUevent hEvent, CUstream hStream );
	int stdcall cuEventQuery( CUevent hEvent );
	int stdcall cuEventSynchronize( CUevent hEvent );
	int stdcall cuEventDestroy( CUevent hEvent );
	int stdcall cuEventElapsedTime( float *pMilliseconds, CUevent hStart, CUevent hEnd );
	int stdcall cuStreamCreate( CUstream *phStream, int Flags );
	int stdcall cuStreamQuery( CUstream hStream );
	int stdcall cuStreamSynchronize( CUstream hStream );
	int stdcall cuStreamDestroy( CUstream hStream );

typedef int cudaError_t
const
	CU_AD_FORMAT_UNSIGNED_INT8  = 0x01,
	CU_AD_FORMAT_UNSIGNED_INT16 = 0x02,
	CU_AD_FORMAT_UNSIGNED_INT32 = 0x03,
	CU_AD_FORMAT_SIGNED_INT8    = 0x08,
	CU_AD_FORMAT_SIGNED_INT16   = 0x09,
	CU_AD_FORMAT_SIGNED_INT32   = 0x0a,
	CU_AD_FORMAT_HALF           = 0x10,
	CU_AD_FORMAT_FLOAT          = 0x20
	CU_TR_ADDRESS_MODE_WRAP = 0,
	CU_TR_ADDRESS_MODE_CLAMP = 1,
	CU_TR_ADDRESS_MODE_MIRROR = 2,
	CU_TR_FILTER_MODE_POINT = 0,
	CU_TR_FILTER_MODE_LINEAR = 1
	CU_TRSA_OVERRIDE_FORMAT =0x01
	CU_TRSF_READ_AS_INTEGER =        0x01
	CU_TRSF_NORMALIZED_COORDINATES = 0x02
	cudaMemcpyHostToHost=0
	cudaMemcpyHostToDevice=1
	cudaMemcpyDeviceToHost=2
	cudaMemcpyDeviceToDevice=3
	cudaChannelFormatKindSigned=0
	cudaChannelFormatKindUnsigned=1
	cudaChannelFormatKindFloat=2
	cudaAddressModeWrap=0
	cudaAddressModeClamp=1
	cudaFilterModePoint=0
	cudaFilterModeLinear=1
	cudaReadModeElementType=1
	cudaReadModeNormalizedFloat=0
	CU_PARAM_TR_DEFAULT=-1
	CU_MEMORYTYPE_HOST = 0x01
	CU_MEMORYTYPE_DEVICE = 0x02
	CU_MEMORYTYPE_ARRAY = 0x03
	CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_BLOCK = 1,
	CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_X = 2,
	CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Y = 3,
	CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Z = 4,
	CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_X = 5,
	CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Y = 6,
	CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Z = 7,
	CU_DEVICE_ATTRIBUTE_MAX_SHARED_MEMORY_PER_BLOCK = 8,
	CU_DEVICE_ATTRIBUTE_SHARED_MEMORY_PER_BLOCK = 8,      // Deprecated, use CU_DEVICE_ATTRIBUTE_MAX_SHARED_MEMORY_PER_BLOCK
	CU_DEVICE_ATTRIBUTE_TOTAL_CONSTANT_MEMORY = 9,
	CU_DEVICE_ATTRIBUTE_WARP_SIZE = 10,
	CU_DEVICE_ATTRIBUTE_MAX_PITCH = 11,
	CU_DEVICE_ATTRIBUTE_MAX_REGISTERS_PER_BLOCK = 12,
	CU_DEVICE_ATTRIBUTE_REGISTERS_PER_BLOCK = 12,         // Deprecated, use CU_DEVICE_ATTRIBUTE_MAX_REGISTERS_PER_BLOCK
	CU_DEVICE_ATTRIBUTE_CLOCK_RATE = 13,
	CU_DEVICE_ATTRIBUTE_TEXTURE_ALIGNMENT = 14,
	CU_DEVICE_ATTRIBUTE_GPU_OVERLAP = 15,
	CU_DEVICE_ATTRIBUTE_MULTIPROCESSOR_COUNT = 16

struct cudaArray
struct cudaChannelFormatDesc
	int x;
	int y;
	int z;
	int w;
	int f;
struct cudaDeviceProp
	char[256] name
	size_t totalGlobalMem;
	size_t sharedMemPerBlock;
	int    regsPerBlock;
	int    warpSize;
	size_t memPitch;
	int    maxThreadsPerBlock;
	int[3]    maxThreadsDim;
	int[3]    maxGridSize;
	size_t totalConstMem;
	int    major;
	int    minor;
	int    clockRate;
	size_t textureAlignment;
struct textureReference
	int normalized
	int filterMode
	int[2] addressMode
	cudaChannelFormatDesc  channelDesc;
struct dim3
	u32 x,y,z
import "cudart.dll"
	//the commented out functions may not be BSGP compatible
	cudaError_t stdcall cudaMalloc(void **devPtr, size_t size);
	cudaError_t stdcall cudaMallocHost(void **ptr, size_t size);
	cudaError_t stdcall cudaMallocPitch(void **devPtr, size_t *pitch, size_t width, size_t height);
	cudaError_t stdcall cudaMallocArray(cudaArray **array, cudaChannelFormatDesc *desc, size_t width, size_t height);
	cudaError_t stdcall cudaFree(void *devPtr);
	cudaError_t stdcall cudaFreeHost(void *ptr);
	cudaError_t stdcall cudaFreeArray(cudaArray *array);
	cudaError_t stdcall cudaMemcpy(void *dst, void *src, size_t count, int kind);
	cudaError_t stdcall cudaMemcpyToArray(cudaArray *dst, size_t wOffset, size_t hOffset, void *src, size_t count, int kind);
	cudaError_t stdcall cudaMemcpyFromArray(void *dst, cudaArray *src, size_t wOffset, size_t hOffset, size_t count, int kind);
	cudaError_t stdcall cudaMemcpyArrayToArray(cudaArray *dst, size_t wOffsetDst, size_t hOffsetDst, cudaArray *src, size_t wOffsetSrc, size_t hOffsetSrc, size_t count, int kind);
	cudaError_t stdcall cudaMemcpy2D(void *dst, size_t dpitch, void *src, size_t spitch, size_t width, size_t height, int kind);
	cudaError_t stdcall cudaMemcpy2DToArray(cudaArray *dst, size_t wOffset, size_t hOffset, void *src, size_t spitch, size_t width, size_t height, int kind);
	cudaError_t stdcall cudaMemcpy2DFromArray(void *dst, size_t dpitch, cudaArray *src, size_t wOffset, size_t hOffset, size_t width, size_t height, int kind);
	cudaError_t stdcall cudaMemcpy2DArrayToArray(cudaArray *dst, size_t wOffsetDst, size_t hOffsetDst, cudaArray *src, size_t wOffsetSrc, size_t hOffsetSrc, size_t width, size_t height, int kind);
	cudaError_t stdcall cudaMemcpyToSymbol(char *symbol, void *src, size_t count, size_t offset , int kind );
	cudaError_t stdcall cudaMemcpyFromSymbol(void *dst, char *symbol, size_t count, size_t offset , int kind );
	cudaError_t stdcall cudaMemset(void *mem, int c, size_t count);
	cudaError_t stdcall cudaMemset2D(void *mem, size_t pitch, int c, size_t width, size_t height);
	/*
	cudaError_t stdcall cudaGetSymbolAddress(void **devPtr, char *symbol);
	cudaError_t stdcall cudaGetSymbolSize(size_t *size, char *symbol);
	*/
	cudaError_t stdcall cudaGetDeviceCount(int *count);
	cudaError_t stdcall cudaGetDeviceProperties(cudaDeviceProp *prop, int device);
	cudaError_t stdcall cudaChooseDevice(int *device, cudaDeviceProp *prop);
	cudaError_t stdcall cudaSetDevice(int device);
	cudaError_t stdcall cudaGetDevice(int *device);
	/*
	cudaError_t stdcall cudaBindTexture(size_t *offset,textureReference *texref, void *devPtr, cudaChannelFormatDesc *desc, size_t size );
	cudaError_t stdcall cudaBindTextureToArray(textureReference *texref, cudaArray *array, cudaChannelFormatDesc *desc);
	cudaError_t stdcall cudaUnbindTexture(textureReference *texref);
	cudaError_t stdcall cudaGetTextureAlignmentOffset(size_t *offset, textureReference *texref);
	cudaError_t stdcall cudaGetTextureReference(textureReference **texref, char *symbol);
	cudaError_t stdcall cudaGetChannelDesc(cudaChannelFormatDesc *desc, cudaArray *array);
	cudaChannelFormatDesc stdcall cudaCreateChannelDesc(int x, int y, int z, int w, int f);
	cudaError_t stdcall cudaGetLastError();
	char* stdcall cudaGetErrorString(cudaError_t error);
	cudaError_t stdcall cudaConfigureCall(dim3 gridDim, dim3 blockDim, size_t sharedMem , int tokens );
	cudaError_t stdcall cudaSetupArgument(void *arg, size_t size, size_t offset);
	cudaError_t stdcall cudaLaunch(char *symbol);
	cudaError_t stdcall cudaThreadExit();
	cudaError_t stdcall cudaThreadSynchronize();
	cudaError_t stdcall cudaGLRegisterBufferObject(u32 bufObj);
	cudaError_t stdcall cudaGLMapBufferObject(void **devPtr, u32 bufObj);
	cudaError_t stdcall cudaGLUnmapBufferObject(u32 bufObj);
	cudaError_t stdcall cudaGLUnregisterBufferObject(u32 bufObj);*/
with detail
	cuglinited=0
	int lasterrid=0
int lasterror
	get()
		ret=detail.lasterrid
		detail.lasterrid=0
		return ret
	set(int a)
		if a:detail.lasterrid=a
inline cudaThreadSynchronize()=cuCtxSynchronize()
_cuGLInit()
	if !detail.cuglinited:{detail.__lazyinit__();detail.cuglinited=1;cuGLInit()}
cudaError_t stdcall cudaGLRegisterBufferObject(u32 bufObj)
	_cuGLInit()
	ret=cuGLRegisterBufferObject(bufObj)
	$$cuda.lasterror=ret
	$$cuda.checkpoint('GL reg')
	return ret
cudaError_t stdcall cudaGLMapBufferObject(void **devPtr, u32 bufObj)
	_cuGLInit()
	unused=0
	ret=cuGLMapBufferObject(devPtr,&unused,bufObj)
	$$cuda.lasterror=ret
	$$cuda.checkpoint('GL map')
	return ret
cudaError_t stdcall cudaGLUnmapBufferObject(u32 bufObj)
	_cuGLInit()
	ret=cuGLUnmapBufferObject(bufObj)
	$$cuda.lasterror=ret
	$$cuda.checkpoint('GL unmap')
	return ret
cudaError_t stdcall cudaGLUnregisterBufferObject(u32 bufObj)
	_cuGLInit()
	ret=cuGLUnregisterBufferObject(bufObj)
	$$cuda.lasterror=ret
	$$cuda.checkpoint('GL unreg')
	return ret
const
	CUDA_SUCCESS                    = 0,
	CUDA_ERROR_INVALID_VALUE        = 1,
	CUDA_ERROR_OUT_OF_MEMORY        = 2,
	CUDA_ERROR_NOT_INITIALIZED      = 3,
	//
	CUDA_ERROR_NO_DEVICE            = 100,
	CUDA_ERROR_INVALID_DEVICE       = 101,
	//
	CUDA_ERROR_INVALID_IMAGE        = 200,
	CUDA_ERROR_INVALID_CONTEXT      = 201,
	CUDA_ERROR_CONTEXT_ALREADY_CURRENT = 202,
	CUDA_ERROR_MAP_FAILED           = 205,
	CUDA_ERROR_UNMAP_FAILED         = 206,
	CUDA_ERROR_ARRAY_IS_MAPPED      = 207,
	CUDA_ERROR_ALREADY_MAPPED       = 208,
	CUDA_ERROR_NO_BINARY_FOR_GPU    = 209,
	CUDA_ERROR_ALREADY_ACQUIRED     = 210,
	CUDA_ERROR_NOT_MAPPED           = 211,
	//
	CUDA_ERROR_INVALID_SOURCE       = 300,
	CUDA_ERROR_FILE_NOT_FOUND       = 301,
	//
	CUDA_ERROR_INVALID_HANDLE       = 400,
	//
	CUDA_ERROR_NOT_FOUND            = 500,
	//
	CUDA_ERROR_NOT_READY            = 600,
	//
	CUDA_ERROR_LAUNCH_FAILED        = 700,
	CUDA_ERROR_LAUNCH_OUT_OF_RESOURCES = 701,
	CUDA_ERROR_LAUNCH_TIMEOUT       = 702,
	CUDA_ERROR_LAUNCH_INCOMPATIBLE_TEXTURING = 703,
	//
	CUDA_ERROR_UNKNOWN              = 999
	//
	CU_JIT_MAX_REGISTERS            = 0,
	CU_JIT_THREADS_PER_BLOCK=1
	CU_JIT_WALL_TIME=2
	CU_JIT_INFO_LOG_BUFFER=3
	CU_JIT_INFO_LOG_BUFFER_SIZE_BYTES=4
	CU_JIT_ERROR_LOG_BUFFER=5
	CU_JIT_ERROR_LOG_BUFFER_SIZE_BYTES=6
	CU_JIT_OPTIMIZATION_LEVEL=7
	CU_JIT_TARGET_FROM_CUCONTEXT=8
	CU_JIT_TARGET=9
	CU_JIT_FALLBACK_STRATEGY=10
	CU_TARGET_COMPUTE_10=0
	CU_TARGET_COMPUTE_11=1
	CU_TARGET_COMPUTE_12=2
	CU_TARGET_COMPUTE_13=3

cudaError_t stdcall cudaGetLastError()=.lasterror
char* stdcall cudaGetErrorString(cudaError_t err)
	static sta
		char[256] ebuf
	switch err{
	default:
		write-sprintf(sta.ebuf;"unspecified driver error ",err)
		=sta.ebuf
	break;case 0:="no error";
	break;case 4:="driver call broken by user";
	break;case CUDA_ERROR_INVALID_VALUE:="invalid parameter value"
	break;case CUDA_ERROR_OUT_OF_MEMORY:="out of memory"
	break;case CUDA_ERROR_NOT_INITIALIZED:="not initialized"
	break;case CUDA_ERROR_NO_DEVICE:="no CUDA device"
	break;case CUDA_ERROR_INVALID_DEVICE:="invalid CUDA device"
	break;case CUDA_ERROR_LAUNCH_FAILED:="kernel crashed"
	break;case CUDA_ERROR_LAUNCH_OUT_OF_RESOURCES:="not enough resources for kernels"
	break;case CUDA_ERROR_LAUNCH_TIMEOUT:="kernel timeout and terminated"
	break;case CUDA_ERROR_LAUNCH_INCOMPATIBLE_TEXTURING:="incompatible texturing"
	break;case CUDA_ERROR_MAP_FAILED:="map failed"
	break;case CUDA_ERROR_UNMAP_FAILED:="unmap failed"
	break;case CUDA_ERROR_ALREADY_MAPPED:="already mapped"
	break;case CUDA_ERROR_INVALID_HANDLE:="invalid handle"
	break;case CUDA_ERROR_INVALID_CONTEXT:="GPU used in a wrong thread"
	break;case CUDA_ERROR_UNKNOWN:="kernel crashed? (unknown error)"
	}

cudaError_t stdcall cudaD3D9Begin(IDirect3DDevice9 *pDevice)
	=cuD3D9Begin(pDevice)
cudaError_t stdcall cudaD3D9End()=cuD3D9End()
cudaError_t stdcall cudaD3D9RegisterVertexBuffer(IDirect3DVertexBuffer9 *pVB)
	=cuD3D9RegisterVertexBuffer(pVB);
cudaError_t stdcall cudaD3D9UnregisterVertexBuffer(IDirect3DVertexBuffer9 *pVB)
	=cuD3D9UnregisterVertexBuffer(pVB)
cudaError_t stdcall cudaD3D9MapVertexBuffer(void **dptr, IDirect3DVertexBuffer9 *pVB)
	dum=0
	=cuD3D9MapVertexBuffer(dptr, &dum, pVB);
cudaError_t stdcall cudaD3D9UnmapVertexBuffer(IDirect3DVertexBuffer9 *pVB)
	=cuD3D9UnmapVertexBuffer(pVB);

const
	CU_CTX_SCHED_AUTO  = 0
	CU_CTX_SCHED_SPIN  = 1
	CU_CTX_SCHED_YIELD = 2
	CU_CTX_SCHED_MASK  = 0x3
	CU_CTX_BLOCKING_SYNC = 4
	CU_CTX_MAP_HOST = 8
	CU_CTX_FLAGS_MASK  = 0xf
	CU_MEMHOSTALLOC_PORTABLE        =0x01
	CU_MEMHOSTALLOC_DEVICEMAP       =0x02
	CU_MEMHOSTALLOC_WRITECOMBINED   =0x04
	CU_EVENT_DEFAULT       = 0
	CU_EVENT_BLOCKING_SYNC = 1
