uses windows
const{
	FD_SETSIZE=64;
};
/meta.ccompat=1
/* also defined in gmon.h and in cygwin's sys/types */
typedef u32	SOCKET;

/* shutdown() how types */
#define SD_RECEIVE      0x00
#define SD_SEND         0x01
#define SD_BOTH         0x02

/* fd_set may be defined by the newlib <sys/types.h>
 * if __USE_W32_SOCKETS not defined.
 */
struct fd_set {
	u32   fd_count;
	SOCKET  fd_array[FD_SETSIZE];
};
#define FD_CLR(fd,set) do { u32 __i;\
for (__i = 0; __i < ((fd_set *)(set))->fd_count ; __i++) {\
	if (((fd_set *)(set))->fd_array[__i] == (fd)) {\
	while (__i < ((fd_set *)(set))->fd_count-1) {\
		((fd_set*)(set))->fd_array[__i] = ((fd_set*)(set))->fd_array[__i+1];\
		__i++;\
	}\
	((fd_set*)(set))->fd_count--;\
	break;\
	}\
}\
} while (0)

/* this differs from the define in winsock.h and in cygwin sys/types.h */
//#define FD_SET(fd, set) do { u32 __i;\
//for (__i = 0; __i < ((fd_set *)(set))->fd_count ; __i++) {\
//	if (((fd_set *)(set))->fd_array[__i] == (fd)) {\
//		break;\
//	}\
//}\
//if (__i == ((fd_set *)(set))->fd_count) {\
//	if (((fd_set *)(set))->fd_count < FD_SETSIZE) {\
//		((fd_set *)(set))->fd_array[__i] = (fd);\
//		((fd_set *)(set))->fd_count++;\
//	}\
//}\
//} while(0)
#define FD_ZERO(set) (((fd_set *)(set))->fd_count=0)
#define FD_ISSET(fd, set) __WSAFDIsSet((SOCKET)(fd), (fd_set *)(set))

struct timeval {
	int    tv_sec;
	int    tv_usec;
};
#define timerisset(tvp)	 ((tvp)->tv_sec || (tvp)->tv_usec)
#define timercmp(tvp, uvp, cmp) \
	(((tvp)->tv_sec != (uvp)->tv_sec) ? \
	((tvp)->tv_sec cmp (uvp)->tv_sec) : \
	((tvp)->tv_usec cmp (uvp)->tv_usec))
#define timerclear(tvp)	 (tvp)->tv_sec = (tvp)->tv_usec = 0

struct  hostent {
	char	*h_name;
	char	**h_aliases;
	short	h_addrtype;
	short	h_length;
	char	**h_addr_list;
#define h_addr h_addr_list[0]
};
struct linger {
	u16 l_onoff;
	u16 l_linger;
};

#define IOCPARM_MASK	0x7f
#define IOC_VOID	0x20000000
#define IOC_OUT	0x40000000
#define IOC_IN	0x80000000
#define IOC_INOUT	(IOC_IN|IOC_OUT)

#define _IO(x,y)	(IOC_VOID|((x)<<8)|(y))
#define _IOR(x,y,t)	(IOC_OUT|(((int)sizeof(t)&IOCPARM_MASK)<<16)|((x)<<8)|(y))
#define _IOW(x,y,t)	(IOC_IN|(((int)sizeof(t)&IOCPARM_MASK)<<16)|((x)<<8)|(y))
#define FIONBIO	_IOW('f', 126, u32)

#define FIONREAD	_IOR('f', 127, u32)
#define FIOASYNC	_IOW('f', 125, u32)
#define SIOCSHIWAT	_IOW('s',  0, u32)
#define SIOCGHIWAT	_IOR('s',  1, u32)
#define SIOCSLOWAT	_IOW('s',  2, u32)
#define SIOCGLOWAT	_IOR('s',  3, u32)
#define SIOCATMARK	_IOR('s',  7, u32)

struct netent {
	char	* n_name;
	char	**n_aliases;
	short	n_addrtype;
	u32 n_net;
};
struct  servent {
	char	*s_name;
	char	**s_aliases;
	short	s_port;
	char	*s_proto;
};
struct  protoent {
	char	*p_name;
	char	**p_aliases;
	short	p_proto;
};

#define IPPROTO_IP	0
#define IPPROTO_ICMP 1
#define IPPROTO_IGMP 2
#define IPPROTO_GGP 3
#define IPPROTO_TCP	6
#define IPPROTO_PUP	12
#define IPPROTO_UDP	17
#define IPPROTO_IDP	22
#define IPPROTO_ND	77
#define IPPROTO_RAW	255
#define IPPROTO_MAX	256
/* IPv6 options */
#define IPPROTO_HOPOPTS		0  /* IPv6 Hop-by-Hop options */
#define IPPROTO_IPV6		41 /* IPv6 header */
#define IPPROTO_ROUTING		43 /* IPv6 Routing header */
#define IPPROTO_FRAGMENT	44 /* IPv6 fragmentation header */
#define IPPROTO_ESP		50 /* encapsulating security payload */
#define IPPROTO_AH		51 /* authentication header */
#define IPPROTO_ICMPV6		58 /* ICMPv6 */
#define IPPROTO_NONE		59 /* IPv6 no next header */
#define IPPROTO_DSTOPTS		60 /* IPv6 Destination options */
#define IPPORT_ECHO	7
#define IPPORT_DISCARD	9
#define IPPORT_SYSTAT	11
#define IPPORT_DAYTIME  13
#define IPPORT_NETSTAT  15
#define IPPORT_FTP      21
#define IPPORT_TELNET   23
#define IPPORT_SMTP     25
#define IPPORT_TIMESERVER 37
#define IPPORT_NAMESERVER 42
#define IPPORT_WHOIS	43
#define IPPORT_MTP	57
#define IPPORT_TFTP	69
#define IPPORT_RJE	77
#define IPPORT_FINGER	79
#define IPPORT_TTYLINK	87
#define IPPORT_SUPDUP	95
#define IPPORT_EXECSERVER	512
#define IPPORT_LOGINSERVER	513
#define IPPORT_CMDSERVER	514
#define IPPORT_EFSSERVER	520
#define IPPORT_BIFFUDP	512
#define IPPORT_WHOSERVER	513
#define IPPORT_ROUTESERVER	520
#define IPPORT_RESERVED	1024
#define IMPLINK_IP	155
#define IMPLINK_LOWEXPER	156
#define IMPLINK_HIGHEXPER       158
struct in_addr {
	union{
		struct { u8 s_net,s_host,s_lh,s_impno; };
		struct { u16 s_w1,s_imp; };
		u32 s_addr;
	};
};
#define IN_CLASSA(i)	(((int)(i)&0x80000000) == 0)
#define IN_CLASSA_NET	0xff000000
#define IN_CLASSA_NSHIFT	24
#define IN_CLASSA_HOST	0x00ffffff
#define IN_CLASSA_MAX	128
#define IN_CLASSB(i)	(((int)(i)&0xc0000000)==0x80000000)
#define IN_CLASSB_NET	   0xffff0000
#define IN_CLASSB_NSHIFT	16
#define IN_CLASSB_HOST	  0x0000ffff
#define IN_CLASSB_MAX	   65536
#define IN_CLASSC(i)	(((int)(i)&0xe0000000)==0xc0000000)
#define IN_CLASSC_NET	   0xffffff00
#define IN_CLASSC_NSHIFT	8
#define IN_CLASSC_HOST	  0xff
#define INADDR_ANY	      (u32)0
#define INADDR_LOOPBACK	 0x7f000001
#define INADDR_BROADCAST	(u32)0xffffffff
#define INADDR_NONE	0xffffffff
struct sockaddr_in {
	short	sin_family;
	u16	sin_port;
	in_addr sin_addr;
	char	sin_zero[8];
};
#define WSADESCRIPTION_LEN	256
#define WSASYS_STATUS_LEN	128
typedef struct WSAData {
	WORD	wVersion;
	WORD	wHighVersion;
	char	szDescription[WSADESCRIPTION_LEN+1];
	char	szSystemStatus[WSASYS_STATUS_LEN+1];
	unsigned short	iMaxSockets;
	unsigned short	iMaxUdpDg;
	char * 	lpVendorInfo;
} WSADATA;
typedef WSADATA *LPWSADATA;

#define IP_OPTIONS	1
#define SO_DEBUG	1
#define SO_ACCEPTCONN	2
#define SO_REUSEADDR	4
#define SO_KEEPALIVE	8
#define SO_DONTROUTE	16
#define SO_BROADCAST	32
#define SO_USELOOPBACK	64
#define SO_LINGER	128
#define SO_OOBINLINE	256
#define SO_DONTLINGER	(u32)(~SO_LINGER)
#define SO_EXCLUSIVEADDRUSE ((u32)(~SO_REUSEADDR))
#define SO_SNDBUF	0x1001
#define SO_RCVBUF	0x1002
#define SO_SNDLOWAT	0x1003
#define SO_RCVLOWAT	0x1004
#define SO_SNDTIMEO	0x1005
#define SO_RCVTIMEO	0x1006
#define SO_ERROR	0x1007
#define SO_TYPE	0x1008
#define INVALID_SOCKET (SOCKET)(~0)
#define SOCKET_ERROR	(-1)
#define SOCK_STREAM	1
#define SOCK_DGRAM	2
#define SOCK_RAW	3
#define SOCK_RDM	4
#define SOCK_SEQPACKET	5
#define TCP_NODELAY	0x0001
#define AF_UNSPEC	0
#define AF_UNIX	1
#define AF_INET	2
#define AF_IMPLINK	3
#define AF_PUP	4
#define AF_CHAOS	5
#define AF_IPX	6
#define AF_NS	6
#define AF_ISO	7
#define AF_OSI	AF_ISO
#define AF_ECMA	8
#define AF_DATAKIT	9
#define AF_CCITT	10
#define AF_SNA	11
#define AF_DECnet	12
#define AF_DLI	13
#define AF_LAT	14
#define AF_HYLINK	15
#define AF_APPLETALK	16
#define AF_NETBIOS	17
#define AF_VOICEVIEW	18
#define	AF_FIREFOX	19
#define	AF_UNKNOWN1	20
#define	AF_BAN	21
#define AF_ATM	22
#define AF_INET6	23
#define AF_CLUSTER  24
#define AF_12844    25
#define AF_IRDA     26
#define AF_NETDES   28
#define AF_MAX	29
struct sockaddr {
	u16 sa_family;
	char	sa_data[14];
};

/* Portable IPv6/IPv4 version of sockaddr.  Based on RFC 2553.
   Pad to force 8 byte alignment and maximum size of 128 bytes. */

/*
 * Desired design of maximum size and alignment
 */
#define _SS_MAXSIZE    128
#define _SS_ALIGNSIZE  (sizeof (i64))
/*
 * Definitions used for sockaddr_storage structure paddings design.
 */
#define _SS_PAD1SIZE   (_SS_ALIGNSIZE - sizeof (short))
#define _SS_PAD2SIZE   (_SS_MAXSIZE - (sizeof (short) \
				+ _SS_PAD1SIZE \
				+ _SS_ALIGNSIZE))
struct sockaddr_storage {
    short ss_family;
    char __ss_pad1[_SS_PAD1SIZE];  /* pad to 8 */
    i64 __ss_align;  	   /* force alignment */
    char __ss_pad2[_SS_PAD2SIZE];  /*  pad to 128 */
};

struct sockproto {
	u16 sp_family;
	u16 sp_protocol;
};
#define PF_UNSPEC	AF_UNSPEC
#define PF_UNIX	AF_UNIX
#define PF_INET	AF_INET
#define PF_IMPLINK	AF_IMPLINK
#define PF_PUP	AF_PUP
#define PF_CHAOS	AF_CHAOS
#define PF_NS	AF_NS
#define PF_IPX	AF_IPX
#define PF_ISO	AF_ISO
#define PF_OSI	AF_OSI
#define PF_ECMA	AF_ECMA
#define PF_DATAKIT	AF_DATAKIT
#define PF_CCITT	AF_CCITT
#define PF_SNA	AF_SNA
#define PF_DECnet	AF_DECnet
#define PF_DLI	AF_DLI
#define PF_LAT	AF_LAT
#define PF_HYLINK	AF_HYLINK
#define PF_APPLETALK	AF_APPLETALK
#define PF_VOICEVIEW	AF_VOICEVIEW
#define PF_FIREFOX	AF_FIREFOX
#define PF_UNKNOWN1	AF_UNKNOWN1
#define PF_BAN	AF_BAN
#define PF_ATM	AF_ATM
#define PF_INET6	AF_INET6
#define PF_MAX	AF_MAX
#define SOL_SOCKET	0xffff
#define SOMAXCONN	0x7fffffff /* (5) in WinSock1.1 */
#define MSG_OOB	1
#define MSG_PEEK	2
#define MSG_DONTROUTE	4
#define MSG_MAXIOVLEN	16
#define MSG_PARTIAL	0x8000
#define MAXGETHOSTSTRUCT	1024

#define FD_READ_BIT      0
#define FD_READ          (1 << FD_READ_BIT)
#define FD_WRITE_BIT     1
#define FD_WRITE         (1 << FD_WRITE_BIT)
#define FD_OOB_BIT       2
#define FD_OOB           (1 << FD_OOB_BIT)
#define FD_ACCEPT_BIT    3
#define FD_ACCEPT        (1 << FD_ACCEPT_BIT)
#define FD_CONNECT_BIT   4
#define FD_CONNECT       (1 << FD_CONNECT_BIT)
#define FD_CLOSE_BIT     5
#define FD_CLOSE         (1 << FD_CLOSE_BIT)
/* winsock1.1 defines stop at FD_CLOSE (32) */
#define FD_QOS_BIT       6
#define FD_QOS           (1 << FD_QOS_BIT)
#define FD_GROUP_QOS_BIT 7
#define FD_GROUP_QOS     (1 << FD_GROUP_QOS_BIT)
#define FD_ROUTING_INTERFACE_CHANGE_BIT 8
#define FD_ROUTING_INTERFACE_CHANGE     (1 << FD_ROUTING_INTERFACE_CHANGE_BIT)
#define FD_ADDRESS_LIST_CHANGE_BIT 9
#define FD_ADDRESS_LIST_CHANGE     (1 << FD_ADDRESS_LIST_CHANGE_BIT)
#define FD_MAX_EVENTS    10
#define FD_ALL_EVENTS    ((1 << FD_MAX_EVENTS) - 1)

#define WSABASEERR	10000
#define WSAEINTR	(WSABASEERR+4)
#define WSAEBADF	(WSABASEERR+9)
#define WSAEACCES	(WSABASEERR+13)
#define WSAEFAULT	(WSABASEERR+14)
#define WSAEINVAL	(WSABASEERR+22)
#define WSAEMFILE	(WSABASEERR+24)
#define WSAEWOULDBLOCK	(WSABASEERR+35)
#define WSAEINPROGRESS	(WSABASEERR+36) /* deprecated on WinSock2 */
#define WSAEALREADY	(WSABASEERR+37)
#define WSAENOTSOCK	(WSABASEERR+38)
#define WSAEDESTADDRREQ	(WSABASEERR+39)
#define WSAEMSGSIZE	(WSABASEERR+40)
#define WSAEPROTOTYPE	(WSABASEERR+41)
#define WSAENOPROTOOPT	(WSABASEERR+42)
#define WSAEPROTONOSUPPORT	(WSABASEERR+43)
#define WSAESOCKTNOSUPPORT	(WSABASEERR+44)
#define WSAEOPNOTSUPP	(WSABASEERR+45)
#define WSAEPFNOSUPPORT	(WSABASEERR+46)
#define WSAEAFNOSUPPORT	(WSABASEERR+47)
#define WSAEADDRINUSE	(WSABASEERR+48)
#define WSAEADDRNOTAVAIL	(WSABASEERR+49)
#define WSAENETDOWN	(WSABASEERR+50)
#define WSAENETUNREACH	(WSABASEERR+51)
#define WSAENETRESET	(WSABASEERR+52)
#define WSAECONNABORTED	(WSABASEERR+53)
#define WSAECONNRESET	(WSABASEERR+54)
#define WSAENOBUFS	(WSABASEERR+55)
#define WSAEISCONN	(WSABASEERR+56)
#define WSAENOTCONN	(WSABASEERR+57)
#define WSAESHUTDOWN	(WSABASEERR+58)
#define WSAETOOMANYREFS	(WSABASEERR+59)
#define WSAETIMEDOUT	(WSABASEERR+60)
#define WSAECONNREFUSED	(WSABASEERR+61)
#define WSAELOOP	(WSABASEERR+62)
#define WSAENAMETOOLONG	(WSABASEERR+63)
#define WSAEHOSTDOWN	(WSABASEERR+64)
#define WSAEHOSTUNREACH	(WSABASEERR+65)
#define WSAENOTEMPTY	(WSABASEERR+66)
#define WSAEPROCLIM	(WSABASEERR+67)
#define WSAEUSERS	(WSABASEERR+68)
#define WSAEDQUOT	(WSABASEERR+69)
#define WSAESTALE	(WSABASEERR+70)
#define WSAEREMOTE	(WSABASEERR+71)
#define WSAEDISCON	(WSABASEERR+101)
#define WSASYSNOTREADY	(WSABASEERR+91)
#define WSAVERNOTSUPPORTED	(WSABASEERR+92)
#define WSANOTINITIALISED	(WSABASEERR+93)
#define WSAHOST_NOT_FOUND	(WSABASEERR+1001)
#define WSATRY_AGAIN	(WSABASEERR+1002)
#define WSANO_RECOVERY	(WSABASEERR+1003)
#define WSANO_DATA	(WSABASEERR+1004)

/* WinSock2 specific error codes */
#define WSAENOMORE	(WSABASEERR+102)
#define WSAECANCELLED	(WSABASEERR+103)
#define WSAEINVALIDPROCTABLE	(WSABASEERR+104)
#define WSAEINVALIDPROVIDER	(WSABASEERR+105)
#define WSAEPROVIDERFAILEDINIT	(WSABASEERR+106)
#define WSASYSCALLFAILURE	(WSABASEERR+107)
#define WSASERVICE_NOT_FOUND	(WSABASEERR+108)
#define WSATYPE_NOT_FOUND	(WSABASEERR+109)
#define WSA_E_NO_MORE	(WSABASEERR+110)
#define WSA_E_CANCELLED	(WSABASEERR+111)
#define WSAEREFUSED	(WSABASEERR+112)

/* WS QualityofService errors */
#define WSA_QOS_RECEIVERS	(WSABASEERR + 1005)
#define WSA_QOS_SENDERS	(WSABASEERR + 1006)
#define WSA_QOS_NO_SENDERS	(WSABASEERR + 1007)
#define WSA_QOS_NO_RECEIVERS	(WSABASEERR + 1008)
#define WSA_QOS_REQUEST_CONFIRMED	(WSABASEERR + 1009)
#define WSA_QOS_ADMISSION_FAILURE	(WSABASEERR + 1010)
#define WSA_QOS_POLICY_FAILURE	(WSABASEERR + 1011)
#define WSA_QOS_BAD_STYLE	(WSABASEERR + 1012)
#define WSA_QOS_BAD_OBJECT	(WSABASEERR + 1013)
#define WSA_QOS_TRAFFIC_CTRL_ERROR	(WSABASEERR + 1014)
#define WSA_QOS_GENERIC_ERROR	(WSABASEERR + 1015)
#define WSA_QOS_ESERVICETYPE	(WSABASEERR + 1016)
#define WSA_QOS_EFLOWSPEC	(WSABASEERR + 1017)
#define WSA_QOS_EPROVSPECBUF	(WSABASEERR + 1018)
#define WSA_QOS_EFILTERSTYLE	(WSABASEERR + 1019)
#define WSA_QOS_EFILTERTYPE	(WSABASEERR + 1020)
#define WSA_QOS_EFILTERCOUNT	(WSABASEERR + 1021)
#define WSA_QOS_EOBJLENGTH	(WSABASEERR + 1022)
#define WSA_QOS_EFLOWCOUNT	(WSABASEERR + 1023)
#define WSA_QOS_EUNKOWNPSOBJ	(WSABASEERR + 1024)
#define WSA_QOS_EPOLICYOBJ	(WSABASEERR + 1025)
#define WSA_QOS_EFLOWDESC	(WSABASEERR + 1026)
#define WSA_QOS_EPSFLOWSPEC	(WSABASEERR + 1027)
#define WSA_QOS_EPSFILTERSPEC	(WSABASEERR + 1028)
#define WSA_QOS_ESDMODEOBJ	(WSABASEERR + 1029)
#define WSA_QOS_ESHAPERATEOBJ	(WSABASEERR + 1030)
#define WSA_QOS_RESERVED_PETYPE	(WSABASEERR + 1031)

#define WSANO_ADDRESS	WSANO_DATA
#define h_errno WSAGetLastError()
#define HOST_NOT_FOUND	WSAHOST_NOT_FOUND
#define TRY_AGAIN	WSATRY_AGAIN
#define NO_RECOVERY	WSANO_RECOVERY
#define NO_DATA	WSANO_DATA
#define NO_ADDRESS	WSANO_ADDRESS


#define WSAMAKEASYNCREPLY(b,e)	MAKELONG(b,e)
#define WSAMAKESELECTREPLY(e,error)	MAKELONG(e,error)
#define WSAGETASYNCBUFLEN(l)	LOWORD(l)
#define WSAGETASYNCERROR(l)	HIWORD(l)
#define WSAGETSELECTEVENT(l)	LOWORD(l)
#define WSAGETSELECTERROR(l)	HIWORD(l)

typedef sockaddr SOCKADDR;
typedef sockaddr *PSOCKADDR;
typedef sockaddr *LPSOCKADDR;
typedef sockaddr_storage SOCKADDR_STORAGE, *PSOCKADDR_STORAGE;
typedef sockaddr_in SOCKADDR_IN;
typedef sockaddr_in *PSOCKADDR_IN;
typedef sockaddr_in *LPSOCKADDR_IN;
typedef linger LINGER;
typedef linger *PLINGER;
typedef linger *LPLINGER;
typedef in_addr IN_ADDR;
typedef in_addr *PIN_ADDR;
typedef in_addr *LPIN_ADDR;
typedef fd_set FD_SET;
typedef fd_set *PFD_SET;
typedef fd_set *LPFD_SET;
typedef hostent HOSTENT;
typedef hostent *PHOSTENT;
typedef hostent *LPHOSTENT;
typedef servent SERVENT;
typedef servent *PSERVENT;
typedef servent *LPSERVENT;
typedef protoent PROTOENT;
typedef protoent *PPROTOENT;
typedef protoent *LPPROTOENT;
typedef timeval TIMEVAL;
typedef timeval *PTIMEVAL;
typedef timeval *LPTIMEVAL;

/* winsock2 additions */
#define ADDR_ANY	INADDR_ANY

#define	IN_CLASSD(i)	(((int)(i) & 0xf0000000) == 0xe0000000)
#define	IN_CLASSD_NET	0xf0000000
#define	IN_CLASSD_NSHIFT	28
#define	IN_CLASSD_HOST	0x0fffffff
#define	IN_MULTICAST(i)	IN_CLASSD(i)

#define	FROM_PROTOCOL_INFO	(-1)

//#define SO_DONTLINGER	(u32)(~SO_LINGER)
#define SO_GROUP_ID	0x2001
#define SO_GROUP_PRIORITY	0x2002
#define SO_MAX_MSG_SIZE	0x2003
#define SO_PROTOCOL_INFOA	0x2004
#define SO_PROTOCOL_INFOW	0x2005
#define SO_PROTOCOL_INFO	SO_PROTOCOL_INFOA
#define PVD_CONFIG        0x3001

#define	MSG_INTERRUPT	0x10
//#define	MSG_MAXIOVLEN	16

#define	WSAAPI	WINAPI
#define WSAEVENT	HANDLE
#define	LPWSAEVENT	LPHANDLE
#define	WSAOVERLAPPED	OVERLAPPED
typedef	_OVERLAPPED	*LPWSAOVERLAPPED;

#define	WSA_IO_PENDING	(ERROR_IO_PENDING)
#define	WSA_IO_INCOMPLETE	(ERROR_IO_INCOMPLETE)
#define	WSA_INVALID_HANDLE	(ERROR_INVALID_HANDLE)
#define	WSA_INVALID_PARAMETER	(ERROR_INVALID_PARAMETER)
#define	WSA_NOT_ENOUGH_MEMORY	(ERROR_NOT_ENOUGH_MEMORY)
#define	WSA_OPERATION_ABORTED	(ERROR_OPERATION_ABORTED)

#define	WSA_INVALID_EVENT	((WSAEVENT)NULL)
#define	WSA_MAXIMUM_WAIT_EVENTS	(MAXIMUM_WAIT_OBJECTS)
#define	WSA_WAIT_FAILED	((DWORD)-1L)
#define	WSA_WAIT_EVENT_0	(WAIT_OBJECT_0)
#define	WSA_WAIT_IO_COMPLETION	(WAIT_IO_COMPLETION)
#define	WSA_WAIT_TIMEOUT	(WAIT_TIMEOUT)
#define	WSA_INFINITE	(INFINITE)

typedef struct _WSABUF {
	unsigned int len;
	char *buf;
} WSABUF, *LPWSABUF;

const{
	BestEffortService=0;
	ControlledLoadService=1;
	PredictiveService=2;
	GuaranteedDelayService=3;
	GuaranteedService=4;
};

/* TODO: FLOWSPEC and related definitions belong in qos.h */

/*
   Windows Sockets 2 Application Programming Interface,
   revision 2.2.2 (1997) uses the type uint32 for SERVICETYPE
   and the elements of _flowspec, but the type uint32 is not defined
   or used anywhere else in the w32api. For now, just use
   unsigned int, which is 32 bits on _WIN32 and _WIN64.
*/

typedef unsigned int	SERVICETYPE;
typedef struct _flowspec
{
	unsigned int	TokenRate;
	unsigned int	TokenBucketSize;
	unsigned int	PeakBandwidth;
	unsigned int	Latency;
	unsigned int	DelayVariation;
	SERVICETYPE	ServiceType;
	unsigned int	MaxSduSize;
	unsigned int	MinimumPolicedSize;
   } FLOWSPEC, *PFLOWSPEC, *LPFLOWSPEC;

typedef struct _QualityOfService
{
	FLOWSPEC	SendingFlowspec;
	FLOWSPEC	ReceivingFlowspec;
	WSABUF	ProviderSpecific;
} QOS, *LPQOS;

#define	CF_ACCEPT	0x0000
#define	CF_REJECT	0x0001
#define	CF_DEFER	0x0002
//#define	SD_RECEIVE	0x00
//#define	SD_SEND	0x01
//#define	SD_BOTH	0x02
typedef unsigned int	GROUP;

#define SG_UNCONSTRAINED_GROUP	0x01
#define SG_CONSTRAINED_GROUP	0x02
typedef struct _WSANETWORKEVENTS {
	int	lNetworkEvents;
	int	iErrorCode[FD_MAX_EVENTS];
} WSANETWORKEVENTS, *LPWSANETWORKEVENTS;

#define	MAX_PROTOCOL_CHAIN 7

#define	BASE_PROTOCOL      1
#define	LAYERED_PROTOCOL   0

typedef int _WSAESETSERVICEOP;
const{
	RNRSERVICE_REGISTER=0;
	RNRSERVICE_DEREGISTER=1;
	RNRSERVICE_DELETE=2;
}
typedef int WSAESETSERVICEOP, *PWSAESETSERVICEOP, *LPWSAESETSERVICEOP;

typedef struct _AFPROTOCOLS {
	INT iAddressFamily;
	INT iProtocol;
} AFPROTOCOLS, *PAFPROTOCOLS, *LPAFPROTOCOLS;

const{
	COMP_EQUAL = 0;
	COMP_NOTLESS=1;
};
typedef int WSAECOMPARATOR, *PWSAECOMPARATOR, *LPWSAECOMPARATOR;

typedef struct _WSAVersion
{
	DWORD	dwVersion;
	WSAECOMPARATOR	ecHow;
} WSAVERSION, *PWSAVERSION, *LPWSAVERSION;

typedef struct _SOCKET_ADDRESS {
	LPSOCKADDR lpSockaddr;
	INT iSockaddrLength;
} SOCKET_ADDRESS,*PSOCKET_ADDRESS,*LPSOCKET_ADDRESS;
typedef struct _CSADDR_INFO {
	SOCKET_ADDRESS LocalAddr;
	SOCKET_ADDRESS RemoteAddr;
	INT iSocketType;
	INT iProtocol;
} CSADDR_INFO,*PCSADDR_INFO,*LPCSADDR_INFO;

typedef struct _SOCKET_ADDRESS_LIST {
    INT             iAddressCount;
    SOCKET_ADDRESS  Address[1];
} SOCKET_ADDRESS_LIST, * LPSOCKET_ADDRESS_LIST;

typedef struct _BLOB {
	ULONG	cbSize;
	BYTE	*pBlobData;
} BLOB,*PBLOB,*LPBLOB;

typedef struct _WSAQuerySetA
{
	DWORD	dwSize;
	LPSTR	lpszServiceInstanceName;
	LPGUID	lpServiceClassId;
	LPWSAVERSION	lpVersion;
	LPSTR	lpszComment;
	DWORD	dwNameSpace;
	LPGUID	lpNSProviderId;
	LPSTR	lpszContext;
	DWORD	dwNumberOfProtocols;
	LPAFPROTOCOLS	lpafpProtocols;
	LPSTR	lpszQueryString;
	DWORD	dwNumberOfCsAddrs;
	LPCSADDR_INFO	lpcsaBuffer;
	DWORD	dwOutputFlags;
	LPBLOB	lpBlob;
} WSAQUERYSETA, *PWSAQUERYSETA, *LPWSAQUERYSETA;

typedef struct _WSAQuerySetW
{
	DWORD	dwSize;
	LPWSTR	lpszServiceInstanceName;
	LPGUID	lpServiceClassId;
	LPWSAVERSION	lpVersion;
	LPWSTR	lpszComment;
	DWORD	dwNameSpace;
	LPGUID	lpNSProviderId;
	LPWSTR	lpszContext;
	DWORD	dwNumberOfProtocols;
	LPAFPROTOCOLS	lpafpProtocols;
	LPWSTR	lpszQueryString;
	DWORD	dwNumberOfCsAddrs;
	LPCSADDR_INFO	lpcsaBuffer;
	DWORD	dwOutputFlags;
	LPBLOB	lpBlob;
} WSAQUERYSETW, *PWSAQUERYSETW, *LPWSAQUERYSETW;

typedef WSAQUERYSETA WSAQUERYSET;
typedef PWSAQUERYSETA PWSAQUERYSET;
typedef LPWSAQUERYSETA LPWSAQUERYSET;

#define LUP_DEEP                0x0001
#define LUP_CONTAINERS          0x0002
#define LUP_NOCONTAINERS        0x0004
#define LUP_NEAREST             0x0008
#define LUP_RETURN_NAME         0x0010
#define LUP_RETURN_TYPE         0x0020
#define LUP_RETURN_VERSION      0x0040
#define LUP_RETURN_COMMENT      0x0080
#define LUP_RETURN_ADDR         0x0100
#define LUP_RETURN_BLOB         0x0200
#define LUP_RETURN_ALIASES      0x0400
#define LUP_RETURN_QUERY_STRING 0x0800
#define LUP_RETURN_ALL          0x0FF0
#define LUP_RES_SERVICE         0x8000
#define LUP_FLUSHCACHE          0x1000
#define LUP_FLUSHPREVIOUS       0x2000

typedef struct _WSANSClassInfoA
{
	LPSTR	lpszName;
	DWORD	dwNameSpace;
	DWORD	dwValueType;
	DWORD	dwValueSize;
	LPVOID	lpValue;
} WSANSCLASSINFOA, *PWSANSCLASSINFOA, *LPWSANSCLASSINFOA;

typedef struct _WSANSClassInfoW
{
	LPWSTR	lpszName;
	DWORD	dwNameSpace;
	DWORD	dwValueType;
	DWORD	dwValueSize;
	LPVOID	lpValue;
} WSANSCLASSINFOW, *PWSANSCLASSINFOW, *LPWSANSCLASSINFOW;

typedef WSANSCLASSINFOA WSANSCLASSINFO;
typedef PWSANSCLASSINFOA PWSANSCLASSINFO;
typedef LPWSANSCLASSINFOA LPWSANSCLASSINFO;

typedef struct _WSAServiceClassInfoA
{
	LPGUID	lpServiceClassId;
	LPSTR	lpszServiceClassName;
	DWORD	dwCount;
	LPWSANSCLASSINFOA	lpClassInfos;
} WSASERVICECLASSINFOA, *PWSASERVICECLASSINFOA, *LPWSASERVICECLASSINFOA;

typedef struct _WSAServiceClassInfoW
{
	LPGUID	lpServiceClassId;
	LPWSTR	lpszServiceClassName;
	DWORD	dwCount;
	LPWSANSCLASSINFOW	lpClassInfos;
} WSASERVICECLASSINFOW, *PWSASERVICECLASSINFOW, *LPWSASERVICECLASSINFOW;

typedef WSASERVICECLASSINFOA WSASERVICECLASSINFO;
typedef PWSASERVICECLASSINFOA PWSASERVICECLASSINFO;
typedef LPWSASERVICECLASSINFOA LPWSASERVICECLASSINFO;

typedef struct _WSANAMESPACE_INFOA {
	GUID	NSProviderId;
	DWORD	dwNameSpace;
	BOOL	fActive;
	DWORD	dwVersion;
	LPSTR	lpszIdentifier;
} WSANAMESPACE_INFOA, *PWSANAMESPACE_INFOA, *LPWSANAMESPACE_INFOA;

typedef struct _WSANAMESPACE_INFOW {
	GUID	NSProviderId;
	DWORD	dwNameSpace;
	BOOL	fActive;
	DWORD	dwVersion;
	LPWSTR	lpszIdentifier;
} WSANAMESPACE_INFOW, *PWSANAMESPACE_INFOW, *LPWSANAMESPACE_INFOW;

typedef WSANAMESPACE_INFOA WSANAMESPACE_INFO;
typedef PWSANAMESPACE_INFOA PWSANAMESPACE_INFO;
typedef LPWSANAMESPACE_INFOA LPWSANAMESPACE_INFO;

typedef struct _WSAPROTOCOLCHAIN {
	int ChainLen;
	DWORD ChainEntries[MAX_PROTOCOL_CHAIN];
} WSAPROTOCOLCHAIN, *LPWSAPROTOCOLCHAIN;

#define WSAPROTOCOL_LEN  255

typedef struct _WSAPROTOCOL_INFOA {
	DWORD dwServiceFlags1;
	DWORD dwServiceFlags2;
	DWORD dwServiceFlags3;
	DWORD dwServiceFlags4;
	DWORD dwProviderFlags;
	GUID ProviderId;
	DWORD dwCatalogEntryId;
	WSAPROTOCOLCHAIN ProtocolChain;
	int iVersion;
	int iAddressFamily;
	int iMaxSockAddr;
	int iMinSockAddr;
	int iSocketType;
	int iProtocol;
	int iProtocolMaxOffset;
	int iNetworkByteOrder;
	int iSecurityScheme;
	DWORD dwMessageSize;
	DWORD dwProviderReserved;
	CHAR szProtocol[WSAPROTOCOL_LEN+1];
} WSAPROTOCOL_INFOA, *LPWSAPROTOCOL_INFOA;

typedef struct _WSAPROTOCOL_INFOW {
	DWORD dwServiceFlags1;
	DWORD dwServiceFlags2;
	DWORD dwServiceFlags3;
	DWORD dwServiceFlags4;
	DWORD dwProviderFlags;
	GUID ProviderId;
	DWORD dwCatalogEntryId;
	WSAPROTOCOLCHAIN ProtocolChain;
	int iVersion;
	int iAddressFamily;
	int iMaxSockAddr;
	int iMinSockAddr;
	int iSocketType;
	int iProtocol;
	int iProtocolMaxOffset;
	int iNetworkByteOrder;
	int iSecurityScheme;
	DWORD dwMessageSize;
	DWORD dwProviderReserved;
	WCHAR  szProtocol[WSAPROTOCOL_LEN+1];
} WSAPROTOCOL_INFOW, * LPWSAPROTOCOL_INFOW;

typedef int ()stdcall(LPWSABUF, LPWSABUF, LPQOS, LPQOS, LPWSABUF, LPWSABUF, GROUP *, DWORD)LPCONDITIONPROC;
typedef void ()stdcall(DWORD, DWORD, LPWSAOVERLAPPED, DWORD)LPWSAOVERLAPPED_COMPLETION_ROUTINE;


typedef WSAPROTOCOL_INFOA WSAPROTOCOL_INFO;
typedef LPWSAPROTOCOL_INFOA LPWSAPROTOCOL_INFO;

/* Needed for XP & .NET Server function WSANSPIoctl.  */
const {
    NSP_NOTIFY_IMMEDIATELY = 0;
    NSP_NOTIFY_HWND=1;
    NSP_NOTIFY_EVENT=2;
    NSP_NOTIFY_PORT=3;
    NSP_NOTIFY_APC=4;
};
typedef int WSACOMPLETIONTYPE, * PWSACOMPLETIONTYPE, * LPWSACOMPLETIONTYPE;
typedef struct _WSACOMPLETION {
    WSACOMPLETIONTYPE Type;
    union _{
        struct _0{
            HWND hWnd;
            UINT uMsg;
            WPARAM context;
        } WindowMessage;
        struct _1{
            LPWSAOVERLAPPED lpOverlapped;
        } Event;
        struct _2{
            LPWSAOVERLAPPED lpOverlapped;
            LPWSAOVERLAPPED_COMPLETION_ROUTINE lpfnCompletionProc;
        } Apc;
        struct _3{
            LPWSAOVERLAPPED lpOverlapped;
            HANDLE hPort;
            ULONG_PTR Key;
        } Port;
    } Parameters;
} WSACOMPLETION, *PWSACOMPLETION, *LPWSACOMPLETION;

typedef struct _TRANSMIT_PACKETS_ELEMENT {
    ULONG  dwElFlags;
    ULONG  cLength;
    union {
      struct {
        LARGE_INTEGER  nFileOffset;
        HANDLE         hFile;
      };
      PVOID  pBuffer;
    };
} TRANSMIT_PACKETS_ELEMENT, *PTRANSMIT_PACKETS_ELEMENT, *LPTRANSMIT_PACKETS_ELEMENT;

#define PFL_MULTIPLE_PROTO_ENTRIES          0x00000001
#define PFL_RECOMMENDED_PROTO_ENTRY         0x00000002
#define PFL_HIDDEN                          0x00000004
#define PFL_MATCHES_PROTOCOL_ZERO           0x00000008
#define XP1_CONNECTIONLESS                  0x00000001
#define XP1_GUARANTEED_DELIVERY             0x00000002
#define XP1_GUARANTEED_ORDER                0x00000004
#define XP1_MESSAGE_ORIENTED                0x00000008
#define XP1_PSEUDO_STREAM                   0x00000010
#define XP1_GRACEFUL_CLOSE                  0x00000020
#define XP1_EXPEDITED_DATA                  0x00000040
#define XP1_CONNECT_DATA                    0x00000080
#define XP1_DISCONNECT_DATA                 0x00000100
#define XP1_SUPPORT_BROADCAST               0x00000200
#define XP1_SUPPORT_MULTIPOINT              0x00000400
#define XP1_MULTIPOINT_CONTROL_PLANE        0x00000800
#define XP1_MULTIPOINT_DATA_PLANE           0x00001000
#define XP1_QOS_SUPPORTED                   0x00002000
#define XP1_INTERRUPT                       0x00004000
#define XP1_UNI_SEND                        0x00008000
#define XP1_UNI_RECV                        0x00010000
#define XP1_IFS_HANDLES                     0x00020000
#define XP1_PARTIAL_MESSAGE                 0x00040000

#define BIGENDIAN                           0x0000
#define LITTLEENDIAN                        0x0001

#define SECURITY_PROTOCOL_NONE              0x0000
#define JL_SENDER_ONLY    0x01
#define JL_RECEIVER_ONLY  0x02
#define JL_BOTH           0x04
#define WSA_FLAG_OVERLAPPED           0x01
#define WSA_FLAG_MULTIPOINT_C_ROOT    0x02
#define WSA_FLAG_MULTIPOINT_C_LEAF    0x04
#define WSA_FLAG_MULTIPOINT_D_ROOT    0x08
#define WSA_FLAG_MULTIPOINT_D_LEAF    0x10
#define IOC_UNIX                      0x00000000
#define IOC_WS2                       0x08000000
#define IOC_PROTOCOL                  0x10000000
#define IOC_VENDOR                    0x18000000

#define _WSAIO(x,y)                   (IOC_VOID|(x)|(y))
#define _WSAIOR(x,y)                  (IOC_OUT|(x)|(y))
#define _WSAIOW(x,y)                  (IOC_IN|(x)|(y))
#define _WSAIORW(x,y)                 (IOC_INOUT|(x)|(y))

#define SIO_ASSOCIATE_HANDLE          _WSAIOW(IOC_WS2,1)
#define SIO_ENABLE_CIRCULAR_QUEUEING  _WSAIO(IOC_WS2,2)
#define SIO_FIND_ROUTE                _WSAIOR(IOC_WS2,3)
#define SIO_FLUSH                     _WSAIO(IOC_WS2,4)
#define SIO_GET_BROADCAST_ADDRESS     _WSAIOR(IOC_WS2,5)
#define SIO_GET_EXTENSION_FUNCTION_POINTER  _WSAIORW(IOC_WS2,6)
#define SIO_GET_QOS                   _WSAIORW(IOC_WS2,7)
#define SIO_GET_GROUP_QOS             _WSAIORW(IOC_WS2,8)
#define SIO_MULTIPOINT_LOOPBACK       _WSAIOW(IOC_WS2,9)
#define SIO_MULTICAST_SCOPE           _WSAIOW(IOC_WS2,10)
#define SIO_SET_QOS                   _WSAIOW(IOC_WS2,11)
#define SIO_SET_GROUP_QOS             _WSAIOW(IOC_WS2,12)
#define SIO_TRANSLATE_HANDLE          _WSAIORW(IOC_WS2,13)
#define SIO_ROUTING_INTERFACE_QUERY   _WSAIORW(IOC_WS2,20)
#define SIO_ROUTING_INTERFACE_CHANGE  _WSAIOW(IOC_WS2,21)
#define SIO_ADDRESS_LIST_QUERY        _WSAIOR(IOC_WS2,22)
#define SIO_ADDRESS_LIST_CHANGE       _WSAIO(IOC_WS2,23)
#define SIO_QUERY_TARGET_PNP_HANDLE   _WSAIOR(IOC_WS2,24)
#define SIO_NSP_NOTIFY_CHANGE         _WSAIOW(IOC_WS2,25)

#define TH_NETDEV	0x00000001
#define TH_TAPI	0x00000002

typedef BOOL()stdcall()LPFN_WSAISBLOCKING;
typedef int()stdcall()LPFN_WSAUNHOOKBLOCKINGHOOK;
typedef FARPROC ()stdcall(FARPROC)LPFN_WSASETBLOCKINGHOOK;
typedef int()stdcall()LPFN_WSACANCELBLOCKINGCALL;
typedef HANDLE()stdcall(HWND, u32, char *, char *, char *, int)LPFN_WSAASYNCGETSERVBYNAME;
typedef HANDLE()stdcall(HWND, u32, int, char *, char *, int)LPFN_WSAASYNCGETSERVBYPORT;
typedef HANDLE()stdcall(HWND, u32, char*, char*, int)LPFN_WSAASYNCGETPROTOBYNAME;
typedef HANDLE()stdcall(HWND, u32, int, char*, int)LPFN_WSAASYNCGETPROTOBYNUMBER;
typedef HANDLE()stdcall(HWND, u32, char*, int, int, char*, int)LPFN_WSAASYNCGETHOSTBYADDR;
typedef int()stdcall(HANDLE)LPFN_WSACANCELASYNCREQUEST;
typedef int()stdcall(SOCKET, HWND, u32, int)LPFN_WSAASYNCSELECT;
typedef SOCKET ()stdcall(SOCKET, sockaddr*,int *)LPFN_ACCEPT;
typedef int ()stdcall(SOCKET, sockaddr*,int)LPFN_BIND;
typedef int ()stdcall(SOCKET)LPFN_CLOSESOCKET;
typedef int ()stdcall(SOCKET, sockaddr*,int)LPFN_CONNECT;
typedef int ()stdcall(SOCKET, int, u32*)LPFN_IOCTLSOCKET;
typedef int	()stdcall(SOCKET, sockaddr*, int*)LPFN_GETPEERNAME;
typedef int()stdcall(SOCKET, sockaddr*, int*)LPFN_GETSOCKNAME;
typedef int()stdcall(SOCKET, int, int, char*, int*)LPFN_GETSOCKOPT;
typedef u32()stdcall(u32)LPFN_HTONL;
typedef u16()stdcall(u16)LPFN_HTONS;
typedef unsigned int()stdcall(char*)LPFN_INET_ADDR;
typedef char*()stdcall(in_addr)LPFN_INET_NTOA;
typedef int()stdcall(SOCKET, int)LPFN_LISTEN;
typedef u32()stdcall(u32)LPFN_NTOHL;
typedef u16()stdcall(u16)LPFN_NTOHS;
typedef int()stdcall(SOCKET, char*, int, int)LPFN_RECV;
typedef int()stdcall(SOCKET, char*, int, int, sockaddr*,  int*)LPFN_RECVFROM;
typedef int()stdcall(int, fd_set*, fd_set*, fd_set*, timeval*)LPFN_SELECT;
typedef int()stdcall(SOCKET, char*, int, int)LPFN_SEND;
typedef int()stdcall(SOCKET, char*, int, int, sockaddr*, int)LPFN_SENDTO;
typedef int()stdcall(SOCKET, int, int, char*, int)LPFN_SETSOCKOPT;
typedef int()stdcall(SOCKET, int)LPFN_SHUTDOWN;
typedef SOCKET()stdcall(int, int, int)LPFN_SOCKET;
typedef hostent*()stdcall( char*, int, int)LPFN_GETHOSTBYADDR;
typedef hostent*()stdcall( char*)LPFN_GETHOSTBYNAME;
typedef int()stdcall(char*, int)LPFN_GETHOSTNAME;
typedef servent*()stdcall(int, char*)LPFN_GETSERVBYPORT;
typedef servent*()stdcall(char*, char*)LPFN_GETSERVBYNAME;
typedef protoent*()stdcall(int)LPFN_GETPROTOBYNUMBER;
typedef protoent*()stdcall(char*)LPFN_GETPROTOBYNAME;
typedef int()stdcall(int, LPWSADATA)LPFN_WSASTARTUP;
typedef int()stdcall()LPFN_WSACLEANUP;
typedef void()stdcall(int)LPFN_WSASETLASTERROR;
typedef int()stdcall()LPFN_WSAGETLASTERROR;
typedef SOCKET ()stdcall(SOCKET, sockaddr *, LPINT, LPCONDITIONPROC, DWORD)LPFN_WSAACCEPT;
typedef INT ()stdcall(LPSOCKADDR, DWORD, LPWSAPROTOCOL_INFOA, LPSTR, LPDWORD)LPFN_WSAADDRESSTOSTRINGA;
typedef INT ()stdcall(LPSOCKADDR, DWORD, LPWSAPROTOCOL_INFOW, LPWSTR, LPDWORD)LPFN_WSAADDRESSTOSTRINGW;
typedef BOOL ()stdcall(WSAEVENT)LPFN_WSACLOSEEVENT;
typedef int ()stdcall(SOCKET, sockaddr *, int, LPWSABUF, LPWSABUF, LPQOS, LPQOS)LPFN_WSACONNECT;
typedef WSAEVENT ()stdcall()LPFN_WSACREATEEVENT;
typedef int ()stdcall(SOCKET, DWORD, LPWSAPROTOCOL_INFOA)LPFN_WSADUPLICATESOCKETA;
typedef int ()stdcall(SOCKET, DWORD, LPWSAPROTOCOL_INFOW)LPFN_WSADUPLICATESOCKETW;
typedef INT ()stdcall(LPDWORD, LPWSANAMESPACE_INFOA)LPFN_WSAENUMNAMESPACEPROVIDERSA;
typedef INT ()stdcall(LPDWORD, LPWSANAMESPACE_INFOW)LPFN_WSAENUMNAMESPACEPROVIDERSW;
typedef int ()stdcall(SOCKET, WSAEVENT, LPWSANETWORKEVENTS)LPFN_WSAENUMNETWORKEVENTS;
typedef int ()stdcall(LPINT, LPWSAPROTOCOL_INFOA, LPDWORD)LPFN_WSAENUMPROTOCOLSA;
typedef int ()stdcall(LPINT, LPWSAPROTOCOL_INFOW, LPDWORD)LPFN_WSAENUMPROTOCOLSW;
typedef int ()stdcall(SOCKET, WSAEVENT, int)LPFN_WSAEVENTSELECT;
typedef BOOL ()stdcall(SOCKET, LPWSAOVERLAPPED, LPDWORD, BOOL, LPDWORD)LPFN_WSAGETOVERLAPPEDRESULT;
typedef BOOL ()stdcall(SOCKET, LPWSABUF, LPQOS)LPFN_WSAGETQOSBYNAME;
typedef INT ()stdcall(LPGUID, LPGUID, LPDWORD, LPWSASERVICECLASSINFOA)LPFN_WSAGETSERVICECLASSINFOA;
typedef INT ()stdcall(LPGUID, LPGUID, LPDWORD, LPWSASERVICECLASSINFOW)LPFN_WSAGETSERVICECLASSINFOW;
typedef INT ()stdcall(LPGUID, LPSTR, LPDWORD)LPFN_WSAGETSERVICECLASSNAMEBYCLASSIDA;
typedef INT ()stdcall(LPGUID, LPWSTR, LPDWORD)LPFN_WSAGETSERVICECLASSNAMEBYCLASSIDW;
typedef int ()stdcall(SOCKET, unsigned int, unsigned int *)LPFN_WSAHTONL;
typedef int ()stdcall(SOCKET, unsigned short, unsigned short *)LPFN_WSAHTONS;
typedef INT ()stdcall(LPWSASERVICECLASSINFOA)LPFN_WSAINSTALLSERVICECLASSA;
typedef INT ()stdcall(LPWSASERVICECLASSINFOW)LPFN_WSAINSTALLSERVICECLASSW;
typedef int ()stdcall(SOCKET, DWORD, LPVOID, DWORD, LPVOID, DWORD, LPDWORD, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE)LPFN_WSAIOCTL;
typedef SOCKET ()stdcall(SOCKET, sockaddr *, int, LPWSABUF, LPWSABUF, LPQOS, LPQOS, DWORD)LPFN_WSAJOINLEAF;
typedef INT ()stdcall(LPWSAQUERYSETA, DWORD, LPHANDLE)LPFN_WSALOOKUPSERVICEBEGINA;
typedef INT ()stdcall(LPWSAQUERYSETW, DWORD, LPHANDLE)LPFN_WSALOOKUPSERVICEBEGINW;
typedef INT ()stdcall(HANDLE, DWORD, LPDWORD, LPWSAQUERYSETA)LPFN_WSALOOKUPSERVICENEXTA;
typedef INT ()stdcall(HANDLE, DWORD, LPDWORD, LPWSAQUERYSETW)LPFN_WSALOOKUPSERVICENEXTW;
typedef INT ()stdcall(HANDLE)LPFN_WSALOOKUPSERVICEEND;
typedef int ()stdcall(HANDLE, DWORD,LPVOID,DWORD,LPVOID,DWORD,LPDWORD,LPWSACOMPLETION)LPFN_WSANSPIoctl;
typedef int ()stdcall(SOCKET, unsigned int, unsigned int *)LPFN_WSANTOHL;
typedef int ()stdcall(SOCKET, unsigned short, unsigned short *)LPFN_WSANTOHS;
typedef int ()stdcall(SOCKET, LPWSABUF, DWORD, LPDWORD, LPDWORD, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE)LPFN_WSARECV;
typedef int ()stdcall(SOCKET, LPWSABUF)LPFN_WSARECVDISCONNECT;
typedef int ()stdcall(SOCKET, LPWSABUF, DWORD, LPDWORD, LPDWORD, sockaddr *, LPINT, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE)LPFN_WSARECVFROM;
typedef INT ()stdcall(LPGUID)LPFN_WSAREMOVESERVICECLASS;
typedef BOOL ()stdcall(WSAEVENT)LPFN_WSARESETEVENT;
typedef int ()stdcall(SOCKET, LPWSABUF, DWORD, LPDWORD, DWORD, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE)LPFN_WSASEND;
typedef int ()stdcall(SOCKET, LPWSABUF)LPFN_WSASENDDISCONNECT;
typedef int ()stdcall(SOCKET, LPWSABUF, DWORD, LPDWORD, DWORD, sockaddr *, int, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE)LPFN_WSASENDTO;
typedef BOOL ()stdcall(WSAEVENT)LPFN_WSASETEVENT;
typedef INT ()stdcall(LPWSAQUERYSETA, WSAESETSERVICEOP, DWORD)LPFN_WSASETSERVICEA;
typedef INT ()stdcall(LPWSAQUERYSETW, WSAESETSERVICEOP, DWORD)LPFN_WSASETSERVICEW;
typedef SOCKET ()stdcall(int, int, int, LPWSAPROTOCOL_INFOA, GROUP, DWORD)LPFN_WSASOCKETA;
typedef SOCKET ()stdcall(int, int, int, LPWSAPROTOCOL_INFOW, GROUP, DWORD)LPFN_WSASOCKETW;
typedef INT ()stdcall(LPSTR, INT, LPWSAPROTOCOL_INFOA, LPSOCKADDR, LPINT)LPFN_WSASTRINGTOADDRESSA;
typedef INT ()stdcall(LPWSTR, INT, LPWSAPROTOCOL_INFOW, LPSOCKADDR, LPINT)LPFN_WSASTRINGTOADDRESSW;
typedef DWORD ()stdcall(DWORD, WSAEVENT *, BOOL, DWORD, BOOL)LPFN_WSAWAITFORMULTIPLEEVENTS;

#define LPFN_WSAADDRESSTOSTRING LPFN_WSAADDRESSTOSTRINGA
#define LPFN_WSADUPLICATESOCKET LPFN_WSADUPLICATESOCKETW
#define LPFN_WSAENUMNAMESPACEPROVIDERS LPFN_WSAENUMNAMESPACEPROVIDERSA
#define LPFN_WSAENUMPROTOCOLS LPFN_WSAENUMPROTOCOLSA
#define LPFN_WSAGETSERVICECLASSINFO LPFN_WSAGETSERVICECLASSINFOA
#define LPFN_WSAGETSERVICECLASSNAMEBYCLASSID LPFN_WSAGETSERVICECLASSNAMEBYCLASSIDA
#define LPFN_WSAINSTALLSERVICECLASS LPFN_WSAINSTALLSERVICECLASSA
#define LPFN_WSALOOKUPSERVICEBEGIN LPFN_WSALOOKUPSERVICEBEGINA
#define LPFN_WSALOOKUPSERVICENEXT LPFN_WSALOOKUPSERVICENEXTA
#define LPFN_WSASETSERVICE  LPFN_WSASETSERVICEA
#define LPFN_WSASOCKET LPFN_WSASOCKETA
#define LPFN_WSASTRINGTOADDRESS LPFN_WSASTRINGTOADDRESSA
#define WSAAddressToString WSAAddressToStringA
#define WSADuplicateSocket WSADuplicateSocketA
#define WSAEnumNameSpaceProviders WSAEnumNameSpaceProvidersA
#define WSAEnumProtocols WSAEnumProtocolsA
#define WSAGetServiceClassInfo WSAGetServiceClassInfoA
#define WSAGetServiceClassNameByClassId WSAGetServiceClassNameByClassIdA
#define WSAInstallServiceClass WSAInstallServiceClassA
#define WSALookupServiceBegin WSALookupServiceBeginA
#define WSALookupServiceNext WSALookupServiceNextA
#define WSASocket WSASocketA
#define WSAStringToAddress WSAStringToAddressA
#define WSASetService WSASetServiceA

/*
 * mswsock.h
 * MS-specific extensions to Windows Sockets, exported from mswsock.dll.
 * These functions are N/A on Windows9x.
 *
 * This file is part of a free library for the Win32 API.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#define SO_CONNDATA	0x7000
#define SO_CONNOPT	0x7001
#define SO_DISCDATA	0x7002
#define SO_DISCOPT	0x7003
#define SO_CONNDATALEN	0x7004
#define SO_CONNOPTLEN	0x7005
#define SO_DISCDATALEN	0x7006
#define SO_DISCOPTLEN	0x7007
#define SO_OPENTYPE	0x7008
#define SO_SYNCHRONOUS_ALERT	0x10
#define SO_SYNCHRONOUS_NONALERT	0x20
#define SO_MAXDG	0x7009
#define SO_MAXPATHDG	0x700A
#define SO_UPDATE_ACCEPT_CONTEXT	0x700B
#define SO_CONNECT_TIME	0x700C
#define TCP_BSDURGENT	0x7000

#define TF_DISCONNECT   1
#define TF_REUSE_SOCKET 2
#define TF_WRITE_BEHIND 4
#define TF_USE_DEFAULT_WORKER   0
#define TF_USE_SYSTEM_THREAD    16
#define TF_USE_KERNEL_APC   32

typedef struct _TRANSMIT_FILE_BUFFERS {
	PVOID Head;
	DWORD HeadLength;
	PVOID Tail;
	DWORD TailLength;
} TRANSMIT_FILE_BUFFERS, *PTRANSMIT_FILE_BUFFERS, *LPTRANSMIT_FILE_BUFFERS;

#define TP_ELEMENT_FILE		1
#define TP_ELEMENT_MEMORY	2
#define TP_ELEMENT_EOP		4

typedef struct _WSAMSG {
	LPSOCKADDR	name;
	INT		namelen;
	LPWSABUF	lpBuffers;
	DWORD		dwBufferCount;
	WSABUF		Control;
	DWORD		dwFlags;
} WSAMSG, *PWSAMSG, *LPWSAMSG;


/* According to MSDN docs, the WSAMSG.Control buffer starts with a
   cmsghdr header of the following form.  See also RFC 2292. */

typedef struct wsacmsghdr {
	UINT	cmsg_len;
	INT	cmsg_level;
	INT	cmsg_type;
	/* followed by UCHAR cmsg_data[]; */
} WSACMSGHDR;

#define WSA_CMSG_FIRSTHDR(mhdr)
#define WSA_CMSG_NXTHDR(mhdr, cmsg)
#define WSA_CMSG_SPACE(length)
#define WSA_CMSG_LEN(length)

import "WS2_32.dll"{
int stdcall __WSAFDIsSet(SOCKET,fd_set*);
SOCKET stdcall accept(SOCKET,sockaddr*,int*);
int stdcall bind(SOCKET,sockaddr*,int);
int stdcall closesocket(SOCKET);
int stdcall connect(SOCKET,sockaddr*,int);
int stdcall ioctlsocket(SOCKET,int,u32 *);
int stdcall getpeername(SOCKET,sockaddr*,int*);
int stdcall getsockname(SOCKET,sockaddr*,int*);
int stdcall getsockopt(SOCKET,int,int,char*,int*);
unsigned int stdcall inet_addr(char*);
char* stdcall inet_ntoa(in_addr);
int stdcall listen(SOCKET,int);
int stdcall recv(SOCKET,char*,int,int);
int stdcall recvfrom(SOCKET,char*,int,int,sockaddr*,int*);
int stdcall send(SOCKET,char*,int,int);
int stdcall sendto(SOCKET,char*,int,int,sockaddr*,int);
int stdcall setsockopt(SOCKET,int,int,char*,int);
int stdcall shutdown(SOCKET,int);
SOCKET stdcall socket(int,int,int);
hostent* stdcall gethostbyaddr(char*,int,int);
hostent* stdcall gethostbyname(char*);
servent* stdcall getservbyport(int,char*);
servent* stdcall getservbyname(char*,char*);
protoent* stdcall getprotobynumber(int);
protoent* stdcall getprotobyname(char*);
int stdcall WSAStartup(int,LPWSADATA);
int stdcall WSACleanup();
void stdcall WSASetLastError(int);
int stdcall WSAGetLastError();
/*
 * Pseudo-blocking functions are deprecated in WinSock2
 * spec. Use threads instead.
 */
BOOL stdcall WSAIsBlocking();
int stdcall WSAUnhookBlockingHook();
FARPROC stdcall WSASetBlockingHook(FARPROC);
int stdcall WSACancelBlockingCall();

HANDLE stdcall WSAAsyncGetServByName(HWND,u32,char*,char*,char*,int);
HANDLE stdcall WSAAsyncGetServByPort(HWND,u32,int,char*,char*,int);
HANDLE stdcall WSAAsyncGetProtoByName(HWND,u32,char*,char*,int);
HANDLE stdcall WSAAsyncGetProtoByNumber(HWND,u32,int,char*,int);
HANDLE stdcall WSAAsyncGetHostByName(HWND,u32,char*,char*,int);
HANDLE stdcall WSAAsyncGetHostByAddr(HWND,u32,char*,int,int,char*,int);
int stdcall WSACancelAsyncRequest(HANDLE);
int stdcall WSAAsyncSelect(SOCKET,HWND,u32,int);
u32 stdcall htonl(int);
u32 stdcall ntohl(int);
u16 stdcall htons(int);
u16 stdcall ntohs(int);
int stdcall select(int nfds,fd_set*,fd_set*,fd_set*,timeval*);

int stdcall gethostname(char*,int);
SOCKET stdcall WSAAccept(SOCKET, sockaddr *, LPINT, LPCONDITIONPROC, DWORD);
INT stdcall WSAAddressToStringA(LPSOCKADDR, DWORD, LPWSAPROTOCOL_INFOA, LPSTR, LPDWORD);
INT stdcall WSAAddressToStringW(LPSOCKADDR, DWORD, LPWSAPROTOCOL_INFOW, LPWSTR, LPDWORD);
BOOL stdcall WSACloseEvent(WSAEVENT);
int stdcall WSAConnect(SOCKET, sockaddr *, int, LPWSABUF, LPWSABUF, LPQOS, LPQOS);
WSAEVENT stdcall WSACreateEvent();
int stdcall WSADuplicateSocketA(SOCKET, DWORD, LPWSAPROTOCOL_INFOA);
int stdcall WSADuplicateSocketW(SOCKET, DWORD, LPWSAPROTOCOL_INFOW);
INT stdcall WSAEnumNameSpaceProvidersA(LPDWORD, LPWSANAMESPACE_INFOA);
INT stdcall WSAEnumNameSpaceProvidersW(LPDWORD, LPWSANAMESPACE_INFOW);
int stdcall WSAEnumNetworkEvents(SOCKET, WSAEVENT, LPWSANETWORKEVENTS);
int stdcall WSAEnumProtocolsA(LPINT, LPWSAPROTOCOL_INFOA, LPDWORD);
int stdcall WSAEnumProtocolsW(LPINT, LPWSAPROTOCOL_INFOW, LPDWORD);
int stdcall WSAEventSelect(SOCKET, WSAEVENT, int);
BOOL stdcall WSAGetOverlappedResult(SOCKET, LPWSAOVERLAPPED, LPDWORD, BOOL, LPDWORD);
BOOL stdcall WSAGetQOSByName(SOCKET, LPWSABUF, LPQOS);
INT stdcall WSAGetServiceClassInfoA(LPGUID, LPGUID, LPDWORD, LPWSASERVICECLASSINFOA);
INT stdcall WSAGetServiceClassInfoW(LPGUID, LPGUID, LPDWORD, LPWSASERVICECLASSINFOW);
INT stdcall WSAGetServiceClassNameByClassIdA(LPGUID, LPSTR, LPDWORD);
INT stdcall WSAGetServiceClassNameByClassIdW(LPGUID, LPWSTR, LPDWORD);
int stdcall WSAHtonl(SOCKET, unsigned int, unsigned int *);
int stdcall WSAHtons(SOCKET, unsigned short, unsigned short *);
INT stdcall WSAInstallServiceClassA(LPWSASERVICECLASSINFOA);
INT stdcall WSAInstallServiceClassW(LPWSASERVICECLASSINFOW);
int stdcall WSAIoctl(SOCKET, DWORD, LPVOID, DWORD, LPVOID, DWORD, LPDWORD, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE);
SOCKET stdcall WSAJoinLeaf(SOCKET, sockaddr *, int, LPWSABUF, LPWSABUF, LPQOS, LPQOS, DWORD);
INT stdcall WSALookupServiceBeginA(LPWSAQUERYSETA, DWORD, LPHANDLE);
INT stdcall WSALookupServiceBeginW(LPWSAQUERYSETW lpqsRestrictions, DWORD, LPHANDLE);
INT stdcall WSALookupServiceNextA(HANDLE, DWORD, LPDWORD, LPWSAQUERYSETA);
INT stdcall WSALookupServiceNextW(HANDLE, DWORD, LPDWORD, LPWSAQUERYSETW);
INT stdcall WSALookupServiceEnd(HANDLE);
int stdcall WSANSPIoctl(HANDLE,DWORD,LPVOID,DWORD,LPVOID,DWORD,LPDWORD,LPWSACOMPLETION); /* XP or .NET Server */
int stdcall WSANtohl(SOCKET, unsigned int, unsigned int *);
int stdcall WSANtohs(SOCKET, unsigned short, unsigned short *);
int stdcall WSARecv(SOCKET, LPWSABUF, DWORD, LPDWORD, LPDWORD, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE);
int stdcall WSARecvDisconnect(SOCKET, LPWSABUF);
int stdcall WSARecvFrom(SOCKET, LPWSABUF, DWORD, LPDWORD, LPDWORD, sockaddr *, LPINT, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE);
INT stdcall WSARemoveServiceClass(LPGUID);
BOOL stdcall WSAResetEvent(WSAEVENT);
int stdcall WSASend(SOCKET, LPWSABUF, DWORD, LPDWORD, DWORD, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE);
int stdcall WSASendDisconnect(SOCKET, LPWSABUF);
int stdcall WSASendTo(SOCKET, LPWSABUF, DWORD, LPDWORD, DWORD, sockaddr *, int, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE);
BOOL stdcall WSASetEvent(WSAEVENT);
INT stdcall WSASetServiceA(LPWSAQUERYSETA, WSAESETSERVICEOP, DWORD);
INT stdcall WSASetServiceW(LPWSAQUERYSETW, WSAESETSERVICEOP, DWORD);
SOCKET stdcall WSASocketA(int, int, int, LPWSAPROTOCOL_INFOA, GROUP, DWORD);
SOCKET stdcall WSASocketW(int, int, int, LPWSAPROTOCOL_INFOW, GROUP, DWORD);
INT stdcall WSAStringToAddressA(LPSTR, INT, LPWSAPROTOCOL_INFOA, LPSOCKADDR, LPINT);
INT stdcall WSAStringToAddressW(LPWSTR, INT, LPWSAPROTOCOL_INFOW, LPSOCKADDR, LPINT);
DWORD stdcall WSAWaitForMultipleEvents(DWORD, WSAEVENT *, BOOL, DWORD, BOOL);
int stdcall WSARecvEx(SOCKET,char*,int,int*);
}
WSAID_TRANSMITFILE=GUID const[0xb5367df0,0xcbac,0x11cf,[0x95,0xca,0x00,0x80,0x5f,0x48,0xa1,0x92]];
WSAID_ACCEPTEX=GUID const[0xb5367df1,0xcbac,0x11cf,[0x95,0xca,0x00,0x80,0x5f,0x48,0xa1,0x92]];
WSAID_GETACCEPTEXSOCKADDRS=GUID const[0xb5367df2,0xcbac,0x11cf,[0x95,0xca,0x00,0x80,0x5f,0x48,0xa1,0x92]];
WSAID_CONNECTEX=GUID const[0x25a207b9,0xddf3,0x4660,[0x8e,0xe9,0x76,0xe5,0x8c,0x74,0x06,0x3e]];
WSAID_DISCONNECTEX=GUID const[0x7fda2e11,0x8630,0x436f,[0xa0, 0x31, 0xf5, 0x36, 0xa6, 0xee, 0xc1, 0x57]];
WSAID_TRANSMITPACKETS=GUID const[0xd9689da0,0x1f90,0x11d3,[0x99,0x71,0x00,0xc0,0x4f,0x68,0xc8,0x76]];
WSAID_WSARECVMSG=GUID const[0xf689d7c8,0x6f1f,0x436b,[0x8a,0x53,0xe5,0x4f,0xe3,0x51,0xc3,0x22]];

static detail{
BOOL ()stdcall (SOCKET,HANDLE,DWORD,DWORD,LPOVERLAPPED,LPTRANSMIT_FILE_BUFFERS,DWORD)TransmitFile=null;
BOOL ()stdcall (SOCKET,SOCKET,PVOID,DWORD,DWORD,DWORD,LPDWORD,LPOVERLAPPED)AcceptEx=null;
VOID ()stdcall (PVOID,DWORD,DWORD,DWORD,sockaddr**, LPINT, sockaddr**, LPINT)GetAcceptExSockaddrs=null;
BOOL ()stdcall (SOCKET, sockaddr *, int, PVOID, DWORD, LPDWORD, LPOVERLAPPED) ConnectEx=null;
BOOL ()stdcall (SOCKET, LPOVERLAPPED, DWORD, DWORD) DisconnectEx=null;
BOOL ()stdcall (SOCKET, LPTRANSMIT_PACKETS_ELEMENT, DWORD, DWORD, LPOVERLAPPED, DWORD) TransmitPackets=null;
INT  ()stdcall (SOCKET, LPWSAMSG, LPDWORD, LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE) WSARecvMsg=null;
void getfuncs(SOCKET sk)
	if(!.TransmitFile){
		nb=0;
		WSAIoctl(sk,SIO_GET_EXTENSION_FUNCTION_POINTER,
			&$WSAID_TRANSMITFILE,sizeof(GUID),
			&.TransmitFile,sizeof(void*),
			&nb,NULL,NULL);
		WSAIoctl(sk,SIO_GET_EXTENSION_FUNCTION_POINTER,
			&$WSAID_ACCEPTEX,sizeof(GUID),
			&.AcceptEx,sizeof(void*),
			&nb,NULL,NULL);
		WSAIoctl(sk,SIO_GET_EXTENSION_FUNCTION_POINTER,
			&$WSAID_GETACCEPTEXSOCKADDRS,sizeof(GUID),
			&.GetAcceptExSockaddrs,sizeof(void*),
			&nb,NULL,NULL);
		WSAIoctl(sk,SIO_GET_EXTENSION_FUNCTION_POINTER,
			&$WSAID_CONNECTEX,sizeof(GUID),
			&.ConnectEx,sizeof(void*),
			&nb,NULL,NULL);
		WSAIoctl(sk,SIO_GET_EXTENSION_FUNCTION_POINTER,
			&$WSAID_DISCONNECTEX,sizeof(GUID),
			&.DisconnectEx,sizeof(void*),
			&nb,NULL,NULL);
		WSAIoctl(sk,SIO_GET_EXTENSION_FUNCTION_POINTER,
			&$WSAID_TRANSMITPACKETS,sizeof(GUID),
			&.TransmitPackets,sizeof(void*),
			&nb,NULL,NULL);
		WSAIoctl(sk,SIO_GET_EXTENSION_FUNCTION_POINTER,
			&$WSAID_WSARECVMSG,sizeof(GUID),
			&.WSARecvMsg,sizeof(void*),
			&nb,NULL,NULL);
	}
}
%BOOL TransmitFile(SOCKET a0,HANDLE a1,DWORD a2,DWORD a3,LPOVERLAPPED a4,LPTRANSMIT_FILE_BUFFERS a5,DWORD a6){
	detail.getfuncs(a0);
	=detail.TransmitFile(a0,a1,a2,a3,a4,a5,a6);
}
%BOOL AcceptEx(SOCKET a0,SOCKET a1,PVOID a2,DWORD a3,DWORD a4,DWORD a5,LPDWORD a6,LPOVERLAPPED a7){
	detail.getfuncs(a0);
	=detail.AcceptEx(a0,a1,a2,a3,a4,a5,a6,a7);
}
%VOID GetAcceptExSockaddrs(PVOID a0,DWORD a1,DWORD a2,DWORD a3,sockaddr** a4, LPINT a5, sockaddr** a6, LPINT a7){
	=detail.GetAcceptExSockaddrs(a0,a1,a2,a3,a4,a5,a6,a7);
}
%BOOL ConnectEx(SOCKET a0, sockaddr *a1, int a2, PVOID a3, DWORD a4, LPDWORD a5, LPOVERLAPPED a6){
	detail.getfuncs(a0);
	=detail.ConnectEx(a0,a1,a2,a3,a4,a5,a6);
}
%BOOL DisconnectEx(SOCKET a0, LPOVERLAPPED a1, DWORD a2, DWORD a3){
	detail.getfuncs(a0);
	if(!detail.DisconnectEx)
		return TransmitFile(a0,null,0,0,a1,null,TF_DISCONNECT|a2);
	return detail.DisconnectEx(a0,a1,a2,a3);
}
%BOOL TransmitPackets(SOCKET a0, LPTRANSMIT_PACKETS_ELEMENT a1, DWORD a2, DWORD a3, LPOVERLAPPED a4, DWORD a5){
	detail.getfuncs(a0);
	=detail.TransmitPackets(a0,a1,a2,a3,a4,a5);
}
%INT WSARecvMsg(SOCKET a0, LPWSAMSG a1, LPDWORD a2, LPWSAOVERLAPPED a3, LPWSAOVERLAPPED_COMPLETION_ROUTINE a4){
	detail.getfuncs(a0);
	=detail.WSARecvMsg(a0,a1,a2,a3,a4);
}
